function Measure=ConcentrationMeasure(Distribution)
%   CONCENTRATIONMEASURE  
%   Measure = CONCENTRATIONMEASURE (Distribution)
%   calculates measure of concentration for prosposed distribution
%   Input parameters:  Distribution - Distribution of interest
%                     
%   Output parameters: Measure - Concentration Measure
%   Paper:"A Virtual Instrument for Time-Frequency Analysis of Signals with
%   Highly Non-Stationary Instantaneous Frequency"
%   Authors: Irena Orovic, Milica Orlandic, Srdjan Stankovic, Zdravko
%   Uskokovic
%   Date: March 2010.
% Copyright (c) by the authors

ACTD4=abs(Distribution);
Measure=10^4*sum(sum(ACTD4.^4))./((sum(sum(ACTD4.^2))).^2);