
function varargout = edit_example(varargin);
% EDIT_EXAMPLE M-file for edit_example.fig
% Paper:"A Virtual Instrument for Time-Frequency Analysis of Signals with
% Highly Non-Stationary Instantaneous Frequency"
% 
% Authors: Irena Orovic, Milica Orlandic, Srdjan Stankovic, Zdravko
% Uskokovic
% 
% The code supports the results in the paper. The codes are written in Matlab 7.
% 
% Version 1, Date: March 2010.
%
% If you publish results using the data, please acknowledge the programs as coming from the
% VIRTUAL INSTRUMENT FOR TIME-FREQUENCY SIGNAL ANALYSIS found at URL: http://www.tfsa.ac.me/Open_source_codes.html
% 
% Copyrigth (c) by the Authors (Irena Orovic, Milica Orlandic, Srdjan Stankovic, Zdravko Uskokovic)
% 
% University of Montenegro
% Faculty of Electrical Engineering
% Time-Frequency Signal Analysis Group
% 20000 Podgorica
% Montenegro
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @edit_example_OpeningFcn, ...
    'gui_OutputFcn',  @edit_example_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before edit_example is made visible.
% --- Opening Function sets initial values

function edit_example_OpeningFcn(hObject, eventdata, handles, varargin)


handles.output = hObject;

% ------------------------------------------------- %
% ---              Monocomponent Panel         ---- %
% ---           Initial No of Samples;         ---- %
% ---    Signal Length; Signal List,Enabled;   ---- %
% ---    Creation of New Signal,Not Enabled;   ---- %
% ------------------------------------------------- %
set(handles.edit2,'String','128');
set(handles.edit4,'String','2');
set(handles.radiobutton1,'Value',1);
handles.signal_val=1;
handles.t=-1+2/128:2/128:1;
handles.signal_selectedname='Signal1';
handles.val=1;
[handles.x,handles.diff_x]=signal(handles.t,handles.signal_val);

set(handles.a1_edit,'String','0');
set(handles.a2_edit,'String','0');
set(handles.a3_edit,'String','0');
set(handles.a4_edit,'String','0');
set(handles.a5_edit,'String','0');
set(handles.a6_edit,'String','0');
set(handles.b1_edit,'String','0');
set(handles.b2_edit,'String','0');
set(handles.b3_edit,'String','0');
set(handles.b4_edit,'String','0');
set(handles.b5_edit,'String','0');
set(handles.b6_edit,'String','0');
set(handles.A_edit,'String','0');
set(handles.signal_popup,'Enable','on');
set(handles.a1_edit,'Enable','off');
set(handles.a2_edit,'Enable','off');
set(handles.a3_edit,'Enable','off');
set(handles.a4_edit,'Enable','off');
set(handles.a5_edit,'Enable','off');
set(handles.a6_edit,'Enable','off');
set(handles.b1_edit,'Enable','off');
set(handles.b2_edit,'Enable','off');
set(handles.b3_edit,'Enable','off');
set(handles.b4_edit,'Enable','off');
set(handles.b5_edit,'Enable','off');
set(handles.b6_edit,'Enable','off');
set(handles.A_edit,'Enable','off');
set(handles.pushbutton_plot,'Enable','off');
% ------------------------------------------------- %

% ------------------------------------------------- %
% ---              Window properties           ---- %
% ---   Initial Size of window, Variance, Type  --- %
% ------------------------------------------------- %
set(handles.edit1,'Enable','on');
set(handles.edit1,'String',get(handles.edit2,'String'));
set(handles.edit1,'Enable','off');
handles.N=str2double(get(handles.edit1,'String'));
handles.Ftau=gausswin(handles.N,16);
handles.selectedname='gausswin';

% ------------------------------------------------- %

% ------------------------------------------------- %
% ---    Plots of Signal and Its Derivative     --- %
% ------------------------------------------------- %
axes(handles.axes2)
plot(handles.t,handles.x);
axes(handles.axes3)
plot(handles.t,handles.diff_x),shading interp
set(handles.axes3,'XMinorTick','on')
% ------------------------------------------------- %

% ------------------------------------------------- %
% ---           Kernel Initialization           --- %
% ------------------------------------------------- %
set(handles.edit_sigma,'String','150');
handles.kernel_val=1;
handles.sigma=str2num(get(handles.edit_sigma,'String'));
handles.const1=1;
handles.const2=1/2;
% ------------------------------------------------- %

% ------------------------------------------------- %
% ---           Multicomponent Panel           ---- %
% ---          Initial No of Samples;          ---- %
% ---     Signal Length; Signal List,Enabled;  ---- %
% ---     Creation of New Signal,Not Enabled;  ---- %
% ------------------------------------------------- %
set(handles.edit_multi,'String','128');
set(handles.edit_length_multi,'String','2');
set(handles.sig2_prop_group,'Visible','off');
set(handles.uipanel_ambiguity,'Visible','off');
handles.popupmenu15_val=1;
handles.popup_multi1_val=1;
handles.popup_amb_val=1;
set(handles.edit57,'Visible','off');
set(handles.edit58,'Visible','off');
set(handles.edit_L,'String','8');
% ------------------------------------------------- %

% ------------------------------------------------- %
% ---            Distribution Panel            ---- %
% ------------------------------------------------- %
set(handles.edit_LL,'String','');
set(handles.edit_LL,'Enable','off');

set(handles.edit_Lform,'String','');
set(handles.edit_Lform,'Enable','off');

set(handles.compare_edit,'String','4');
set(handles.compare_edit,'Enable','off');
% ------------------------------------------------- %

% ------------------------------------------------- %
% ---            Compare Panel                 ---- %
% ---          Compare Axes Visible            ---- %
% --- Monocomponent Popups Visible,Not Enabled ---- %
% ---     Multicomponent Popups Not Visible    ---- %
% ------------------------------------------------- %
handles.popup1_val=1;
handles.popup1_name='SPEC';
handles.popup2_val=1;
handles.popup2_name='SPEC';
handles.popup3_val=1;
handles.popup3_name='SPEC';
handles.popup4_val=1;
handles.popup4_name='SPEC';
set(handles.axes1,'Visible','on');
set(handles.axes4,'Visible','on');
set(handles.axes5,'Visible','on');
set(handles.axes6,'Visible','on');
set(handles.axes7,'Visible','on');
set(handles.popup1m,'Visible','off');
set(handles.popup2m,'Visible','off');
set(handles.popup3m,'Visible','off');
set(handles.popup1,'Enable','off');
set(handles.popup2,'Enable','off');
set(handles.popup3,'Enable','off');
set(handles.popup4,'Enable','off');
% ------------------------------------------------- %

% ------------------------------------------------- %
% ---              MEAN Error Panel            ---- %
% ---  Initial Value of Threshold, Comments    ---- %
% ------------------------------------------------- %
set(handles.text61,'Visible','off');
set(handles.text56,'Visible','on');
set(handles.text62,'Visible','off');
set(handles.text63,'Visible','off');
set(handles.edit63,'String','0.01');
set(handles.text75,'Visible','off');
set(handles.text76,'Visible','off');
set(handles.text78,'Visible','off');
set(handles.popupmenu15,'Visible','off');
% ------------------------------------------------- %

% --- Parameter check
set(handles.edit3,'String','0');

% ------------------------------------------------- %
% ---   Panels Update with Button Functions    ---- %
% ------------------------------------------------- %
set(handles.distribution_panel,'SelectionChangeFcn',@distribution_panel_SelectionChangeFcn);
set(handles.uipanel7,'SelectionChangeFcn',@uipanel7_SelectionChangeFcn);
set(handles.uipanel32,'SelectionChangeFcn',@uipanel32_SelectionChangeFcn);
% ------------------------------------------------- %
% Update handles structure
guidata(hObject, handles);


function varargout = edit_example_OutputFcn(hObject, eventdata, handles)
varargout{1} = handles.output;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ---        EDIT FUNCTIONS                    ---- %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ------------------------------------------------- %
% ---  Edit1 Function Callback and Create Fcn  ---- %
% ---  Edit: Window's size                     ---- %
% ------------------------------------------------- %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function edit1_Callback(hObject, eventdata, handles)
guidata(hObject,handles);
% ------------------------------------------------- %
function edit1_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ------------------------------------------------- %
% ---  Edit2 Function Callback and Create Fcn  ---- %
% ---  Edit: Number of Samples                 ---- %
% ------------------------------------------------- %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [handles]=edit2_Callback(hObject, eventdata, handles);

set(handles.edit1,'Enable','on');
set(handles.edit1,'String',get(handles.edit2,'String'));
set(handles.edit1,'Enable','off');
handles.R=str2double(get(handles.edit2,'String'));
set(handles.edit3,'String',get(handles.edit2,'String'));
guidata(hObject,handles);
% ------------------------------------------------- %
function edit2_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ------------------------------------------------- %
% ---  Edit3 Function Callback and Create Fcn  ---- %
% ---  Edit: Parameter Check                   ---- %
% ------------------------------------------------- %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [handles]=edit3_Callback(hObject, eventdata, handles);
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function edit3_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ------------------------------------------------- %
% ---  Edit4 Function Callback and Create Fcn  ---- %
% ---  Description: Signal Lenght              ---- %
% ------------------------------------------------- %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function edit4_Callback(hObject, eventdata, handles)
guidata(hObject,handles);
function edit4_CreateFcn(hObject, eventdata, handles)
% ------------------------------------------------- %
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ------------------------------------------------- %
% ---            NEW SIGNAL PANEL:             ---- %
% ---   A_Edit Callback and CreateFcn          ---- %
% ---   Description: Amplitude                 ---- %
% ---                                          ---- %
% ---   a1_Edit, a2_Edit, a3_Edit, a4_Edit,    ---- %
% ---   a5_Edit,a6_Edit Callback and CreateFcn ---- %
% ---   Description: Multiplication factors    ---- %
% ---                of sin and cos functions  ---- %
% ---                                          ---- %
% ---   b1_Edit, b2_Edit, b3_Edit, b4_Edit,    ---- %
% ---   b5_Edit,b6_Edit Callback and CreateFcn ---- %
% ---   Description: Multiplication factors    ---- %
% ---                in sin and cos functions  ---- %
% ------------------------------------------------- %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function A_edit_Callback(hObject, eventdata, handles)
guidata(hObject, handles)
% ------------------------------------------------- %
function A_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function a1_edit_Callback(hObject, eventdata, handles)
% ------------------------------------------------- %
function a1_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function a2_edit_Callback(hObject, eventdata, handles)
function a2_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function a3_edit_Callback(hObject, eventdata, handles)
function a3_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function a4_edit_Callback(hObject, eventdata, handles)
% ------------------------------------------------- %
function a4_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function a5_edit_Callback(hObject, eventdata, handles)
% ------------------------------------------------- %
function a5_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function a6_edit_Callback(hObject, eventdata, handles)
% ------------------------------------------------- %
function a6_edit_CreateFcn(hObject, eventdata, handles)

if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function b1_edit_Callback(hObject, eventdata, handles)
% ------------------------------------------------- %
function b1_edit_CreateFcn(hObject, eventdata, handles)

if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function b2_edit_Callback(hObject, eventdata, handles)
% ------------------------------------------------- %
function b2_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function b3_edit_Callback(hObject, eventdata, handles)
% ------------------------------------------------- %
function b3_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function b4_edit_Callback(hObject, eventdata, handles)
% ------------------------------------------------- %
function b4_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function b5_edit_Callback(hObject, eventdata, handles)
% ------------------------------------------------- %
function b5_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function b6_edit_Callback(hObject, eventdata, handles)
function b6_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ------------------------------------------------- %
% --- Edit50 Fcn Callback and Create Fcn  --- %
% ---  Description:          ---- %
% ---                  ---- %
% ------------------------------------------------- %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function edit50_Callback(hObject, eventdata, handles)
function edit50_CreateFcn(hObject, eventdata, handles)

if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ------------------------------------------------- %
% --- Edit_Wigner_L Fcn Callback and Create Fcn --- %
% ---  Description:          ---- %
% ---                  ---- %
% ------------------------------------------------- %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function edit_wigner_L_Callback(hObject, eventdata, handles)
function edit_wigner_L_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ------------------------------------------------- %
% --- Edit_LL Fcn Callback and Create Fcn  --- %
% ---  Description:          ---- %
% ---                  ---- %
% ------------------------------------------------- %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function edit_LL_Callback(hObject, eventdata, handles)
function edit_LL_CreateFcn(hObject, eventdata, handles)

if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ------------------------------------------------- %
% ---  Edit57 Function Callback and Create Fcn ---- %
% ---  Description:          ---- %
% ---                  ---- %
% ------------------------------------------------- %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function edit57_Callback(hObject, eventdata, handles)
function edit57_CreateFcn(hObject, eventdata, handles)

if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ------------------------------------------------- %
% ---  Edit58 Function Callback and Create Fcn ---- %
% ---  Description:           ---- %
% ---                  ---- %
% ------------------------------------------------- %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function edit58_Callback(hObject, eventdata, handles)
function edit58_CreateFcn(hObject, eventdata, handles)

if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ------------------------------------------------- %
% ---  Edit59 Function Callback and Create Fcn ---- %
% ---  Description: Calculated MSE             ---- %
% ---         of Wigner Distribution           ---- %
% ------------------------------------------------- %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function edit59_Callback(hObject, eventdata, handles)
function edit59_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ------------------------------------------------- %
% ---  Edit61 Function Callback and Create Fcn ---- %
% ---  Description: Calculated MSE             ---- %
% ---         of Complex 4 Distribution        ---- %
% ------------------------------------------------- %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function edit61_Callback(hObject, eventdata, handles)
function edit61_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ------------------------------------------------- %
% ---  Edit62 Function Callback and Create Fcn ---- %
% ---  Description: Calculated MSE             ---- %
% ---         of Complex 6 Distribution        ---- %
% ------------------------------------------------- %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function edit62_Callback(hObject, eventdata, handles)
function edit62_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ------------------------------------------------- %
% ---  Edit63 Function Callback and Create Fcn ---- %
% ---  Description:          ---- %
% ------------------------------------------------- %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function edit63_Callback(hObject, eventdata, handles)
function edit63_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ------------------------------------------------- %
% ---  Edit_Sigma Function Callback and Create Fcn ---- %
% ---  Description:          ---- %
% ------------------------------------------------- %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function edit_sigma_Callback(hObject, eventdata, handles)

function edit_sigma_CreateFcn(hObject, eventdata, handles)

if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ------------------------------------------------- %
% ---  Edit_L Function Callback and Create Fcn ---- %
% ---  Description:          ---- %
% ------------------------------------------------- %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function edit_L_Callback(hObject, eventdata, handles)
function edit_L_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ---  Compare_Edit Fcn Callback and Create Fcn---- %
% ---  Description: Number of distributions    ---- %
% ---               to be compared             ---- %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function compare_edit_Callback(hObject, eventdata, handles)

if str2double(get(handles.compare_edit,'String'))==1
    set(handles.axes1,'Visible','on');
    set(handles.axes4,'Visible','on');
    set(handles.axes5,'Visible','off');
    set(handles.axes6,'Visible','off');
    set(handles.axes7,'Visible','off');
    set(handles.popup1,'Enable','on');
    set(handles.popup2,'Enable','off');
    set(handles.popup3,'Enable','off');
    set(handles.popup4,'Enable','off');

elseif get(handles.compare_edit,'String')=='2'
    set(handles.axes1,'Visible','on');
    set(handles.axes4,'Visible','on');
    set(handles.axes5,'Visible','on');
    set(handles.axes6,'Visible','off');
    set(handles.axes7,'Visible','off');
    set(handles.popup1,'Enable','on');
    set(handles.popup2,'Enable','on');
    set(handles.popup3,'Enable','off');
    set(handles.popup4,'Enable','off');

elseif get(handles.compare_edit,'String')=='3'
    set(handles.axes1,'Visible','on');
    set(handles.axes4,'Visible','on');
    set(handles.axes5,'Visible','on');
    set(handles.axes6,'Visible','on');
    set(handles.axes7,'Visible','off');
    set(handles.popup1,'Enable','on');
    set(handles.popup2,'Enable','on');
    set(handles.popup3,'Enable','on');
    set(handles.popup4,'Enable','off');

elseif get(handles.compare_edit,'String')=='4'
    set(handles.axes1,'Visible','on');
    set(handles.axes4,'Visible','on');
    set(handles.axes5,'Visible','on');
    set(handles.axes6,'Visible','on');
    set(handles.axes7,'Visible','on');
    set(handles.popup1,'Enable','on');
    set(handles.popup2,'Enable','on');
    set(handles.popup3,'Enable','on');
    set(handles.popup4,'Enable','on');
end
function compare_edit_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ---  Edit_Multi Fcn Callback and Create Fcn  ---- %
% ---  Description: Number of samples          ---- %
% ---              Multicomponent signal panel ---- %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function edit_multi_Callback(hObject, eventdata, handles)
set(handles.edit1,'String',get(handles.edit_multi,'String'));
set(handles.edit1,'Enable','on');
guidata(hObject,handles)
function edit_multi_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ---  Edit_Length_Multi Fcn Callback          ---- %
% ---  Description:       ---- %
% ---             ---- %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function edit_length_multi_Callback(hObject, eventdata, handles)
function edit_length_multi_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ------------------------------------------------- %
% ---            POPUPS FUNCTIONS              ---- %
% ------------------------------------------------- %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ------------------------------------------------- %
% ---    WINDOW_POPUP Function Callback        ---- %
% ---    Choice of Window's Type:              ---- %
% ---        Gaussian, Hamming, Hann           ---- %
% ------------------------------------------------- %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [handles]=window_popup_Callback(hObject, eventdata, handles);

handles.val = get (hObject,'Value');
list = get(hObject,'String');
handles.selectedname = list{handles.val};

guidata(hObject,handles)
% ------------------------------------------------- %
function window_popup_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ------------------------------------------------- %
% ---    SIGNAL_POPUP Function Callback        ---- %
% ---    Choice of Signal from the List        ---- %
% ---    Signal1, Signal2, SIgnal3, Signal4    ---- %
% ------------------------------------------------- %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [handles]=signal_popup_Callback(hObject, eventdata, handles);

cla(handles.axes1)
cla(handles.axes4)
cla(handles.axes5)
cla(handles.axes6)
set(handles.text75,'String','')
set(handles.text76,'String','')
set(handles.text77,'String','')
set(handles.text78,'String','')

handles.signal_val = get (hObject,'Value');
list = get(hObject,'String');
handles.signal_selectedname = list{handles.signal_val};

if get(handles.radiobutton1,'Value')
    [handles.x,handles.diff_x]=signal(handles.t,handles.signal_val);
end
axes(handles.axes2)
plot(handles.t,handles.x);

axes(handles.axes3)
plot(handles.t,handles.diff_x),shading interp
set(handles.axes3,'XMinorTick','on')

if get(handles.checkbox_mse,'Value')
    set(handles.edit59,'String','');
    set(handles.edit61,'String','');
    set(handles.edit62,'String','');
    set(handles.text71,'String','');
    set(handles.text72,'String','');
    set(handles.text73,'String','');
    set(handles.text75,'String','');
    set(handles.text76,'String','');
    set(handles.text77,'String','');
    set(handles.text78,'String','');
    cla(handles.axes1)
    cla(handles.axes4)
    cla(handles.axes5)
    cla(handles.axes6)
    cla(handles.axes7)
end

if get(handles.compare_check,'Value')
    cla(handles.axes1)
    cla(handles.axes4)
    cla(handles.axes5)
    cla(handles.axes6)
    cla(handles.axes7)
end
set(handles.uipanel7,'SelectionChangeFcn',@uipanel7_SelectionChangeFcn);
guidata(hObject, handles)
% ------------------------------------------------- %
function signal_popup_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ------------------------------------------------- %
% ---    POPUP1 Function Callback              ---- %
% ---          ---- %
% ---        ---- %
% ------------------------------------------------- %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [handles]=popup1_Callback(hObject, eventdata, handles);

handles.popup1_val = get (hObject,'Value');
list = get(hObject,'String');
handles.popup1_name = list{handles.popup1_val};
guidata(hObject,handles)

function popup1_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ------------------------------------------------- %
% ---    POPUP2 Function Callback              ---- %
% ---          ---- %
% ---        ---- %
% ------------------------------------------------- %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [handles]=popup2_Callback(hObject, eventdata, handles);

handles.popup2_val = get (hObject,'Value');
list = get(hObject,'String');
handles.popup2_name = list{handles.popup2_val};
guidata(hObject,handles);

function popup2_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ------------------------------------------------- %
% ---    POPUP3 Function Callback              ---- %
% ---          ---- %
% ---        ---- %
% ------------------------------------------------- %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [handles]=popup3_Callback(hObject, eventdata, handles);
handles.popup3_val = get (hObject,'Value');
list = get(hObject,'String');
handles.popup3_name = list{handles.popup3_val};
guidata(hObject,handles);

function popup3_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ------------------------------------------------- %
% ---    POPUP4 Function Callback              ---- %
% ---          ---- %
% ---        ---- %
% ------------------------------------------------- %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [handles]=popup4_Callback(hObject, eventdata, handles);

handles.popup4_val = get (hObject,'Value');
list = get(hObject,'String');
handles.popup4_name = list{handles.popup4_val};
guidata(hObject,handles);

function popup4_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ------------------------------------------------- %
% ---    POPUP1m Function Callback             ---- %
% ---          ---- %
% ---        ---- %
% ------------------------------------------------- %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [handles]=popup1m_Callback(hObject, eventdata, handles)

handles.popup1m_val = get (hObject,'Value');
list = get(hObject,'String');
handles.popup1m_name = list{handles.popup1m_val};
guidata(hObject,handles);


function popup1m_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ------------------------------------------------- %
% ---    POPUP2m Function Callback             ---- %
% ---          ---- %
% ---        ---- %
% ------------------------------------------------- %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [handles]=popup2m_Callback(hObject, eventdata, handles)
handles.popup2m_val = get (hObject,'Value');
list = get(hObject,'String');
handles.popup2m_name = list{handles.popup2m_val};
guidata(hObject,handles);


function popup2m_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ------------------------------------------------- %
% ---    POPUP3m Function Callback             ---- %
% ---          ---- %
% ---        ---- %
% ------------------------------------------------- %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function popup3m_Callback(hObject, eventdata, handles)
handles.popup3m_val = get (hObject,'Value');
list = get(hObject,'String');
handles.popup3m_name = list{handles.popup3m_val};
guidata(hObject,handles);

% --- Executes during object creation, after setting all properties.
function popup3m_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ------------------------------------------------- %
% ---    POPUP_MULTI1 Function Callback        ---- %
% ---          ---- %
% ---        ---- %
% ------------------------------------------------- %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [handles]=popup_multi1_Callback(hObject, eventdata, handles);

handles.popup_multi1_val = get (hObject,'Value');
list = get(hObject,'String');
handles.popup_multi1_name = list{handles.popup_multi1_val};

[handles.x,handles.diff_x1,handles.diff_x2]=signal_multi(handles.t,handles.popup_multi1_val);
axes(handles.axes2)
plot(handles.t,handles.x);
axes(handles.axes3)
plot(handles.t,handles.diff_x1);
hold on
plot(handles.t,handles.diff_x2);
hold off

guidata(hObject,handles)

function popup_multi1_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ------------------------------------------------- %
% ---    POPUP_MENU15 Function Callback        ---- %
% ---          ---- %
% ---        ---- %
% ------------------------------------------------- %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function popupmenu15_Callback(hObject, eventdata, handles)

handles.popupmenu15_val = get (hObject,'Value');
list = get(hObject,'String');
handles.popupmenu15_name = list{handles.popupmenu15_val};

switch (handles.popupmenu15_val)
    case 1
        set(handles.edit58,'String','16');
        set(handles.edit58,'Enable','on');
        set(handles.text62,'String','LL');
        set(handles.edit57,'Visible','on');
        set(handles.edit57,'Enable','on');
        set(handles.text63,'Visible','on');
        set(handles.text75,'Visible','off');
        set(handles.text76,'Visible','off');
        set(handles.text78,'Visible','off');
        set(handles.popup1m,'Visible','on');
        set(handles.popup2m,'Visible','on');
    case 2
        handles.popupmenu15_val==2
        set(handles.edit58,'String','3');
        set(handles.edit58,'Enable','on');
        set(handles.text62,'String','LL');
        set(handles.edit57,'Visible','off');
        set(handles.text63,'Visible','off');
        set(handles.popup1m,'Visible','off');
        set(handles.popup2m,'Visible','off');
        set(handles.text75,'Visible','on','String','SPEC','FontSize',10);
        set(handles.text76,'Visible','on','String','SM','FontSize',10);
    case 3
        set(handles.edit58,'String','5');
        set(handles.edit58,'Enable','on');
        set(handles.text62,'String','LL');
        set(handles.edit57,'Visible','off');
        set(handles.text63,'Visible','off');
        set(handles.popup1m,'Visible','off');
        set(handles.popup2m,'Visible','off');
        set(handles.text75,'Visible','on','String','SPEC','FontSize',10);
        set(handles.text76,'Visible','on','String','SM','FontSize',10);
        
end
guidata(hObject,handles)

function popupmenu15_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ------------------------------------------------- %
% ---    POPUP_KERNEL Function Callback        ---- %
% ---          ---- %
% ---        ---- %
% ------------------------------------------------- %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [handles]=popup_kernel_Callback(hObject, eventdata, handles)
handles.kernel_val = get (hObject,'Value');
list = get(hObject,'String');
handles.kernel_name = list{handles.kernel_val};
switch(handles.popup_amb_val)
    case 1
        set(handles.popup_kernel,'Enable','on')
        set(handles.edit_sigma,'Visible','on');
        set(handles.text59,'Visible','on');
        switch (handles.kernel_val)
            case 1 
                handles.const1=1;
                handles.const2=1/2;
                set(handles.edit_sigma,'String','150');
                set(handles.edit_sigma,'Visible','on');
                set(handles.text59,'Visible','on');
            case 2
                handles.const1=2;
                handles.const2=1;
                set(handles.edit_sigma,'String','10');
                set(handles.edit_sigma,'Visible','on');
                set(handles.text59,'Visible','on');
            case 3
                handles.const1=1;
                handles.const2=1;
                set(handles.edit_sigma,'String','120');
                set(handles.edit_sigma,'Visible','on');
                set(handles.text59,'Visible','on');
            case 4
                handles.const1=1;
                handles.const2=10;
                set(handles.edit_sigma,'Visible','off');
                set(handles.text59,'Visible','off');
        end
    case 2
        set(handles.popup_kernel,'Value',1)
        set(handles.popup_kernel,'Enable','off')
        set(handles.edit_sigma,'Visible','on');
        set(handles.text59,'Visible','on');
        
        if get(handles.radiobutton_ctd4,'Value') 
            handles.const1=1.5;
            handles.const2=1;
            set(handles.edit_sigma,'String','80');
            set(handles.edit_L,'String','8');
        elseif get(handles.radiobutton_ctd6,'Value')
            handles.const1=1;
            handles.const2=1/3;
            set(handles.edit_sigma,'String','150');
            set(handles.edit_L,'String','12');
        end
       
end
guidata(hObject,handles);

function popup_kernel_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% ------------------------------------------------- %
% ---            PANELS                        ---- %
% ------------------------------------------------- %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ------------------------------------------------- %
% --- UIPANEL17 Function Callback              ---- %
% --- Description: Signal Choice               ---- %
% --- Monocomponent PANEL                      ---- %
% ------------------------------------------------- %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function uipanel7_CreateFcn(hObject, eventdata, handles)
function [handles]=uipanel7_SelectionChangeFcn(hObject, eventdata);
handles=guidata(hObject);
switch get(eventdata.NewValue,'Tag')
    % ------------------------------------------------- %
    % --- RADIOBUTTON1, DEFINED SIGNAL             ---- %
    % ------------------------------------------------- %
    case 'radiobutton1'
        set(handles.signal_popup,'Enable','on');
        set(handles.a1_edit,'Enable','off');
        set(handles.a2_edit,'Enable','off');
        set(handles.a3_edit,'Enable','off');
        set(handles.a4_edit,'Enable','off');
        set(handles.a5_edit,'Enable','off');
        set(handles.a6_edit,'Enable','off');
        set(handles.b1_edit,'Enable','off');
        set(handles.b2_edit,'Enable','off');
        set(handles.b3_edit,'Enable','off');
        set(handles.b4_edit,'Enable','off');
        set(handles.b5_edit,'Enable','off');
        set(handles.b6_edit,'Enable','off');
        set(handles.A_edit,'Enable','off');
        set(handles.pushbutton_plot,'Enable','off');
        % ------------------------------------------------- %
        % --- RADIOBUTTON2, MAKE A SIGNAL              ---- %
        % ------------------------------------------------- %
    case 'radiobutton2'
        set(handles.signal_popup,'Enable','off');
        set(handles.a1_edit,'Enable','on');
        set(handles.a2_edit,'Enable','on');
        set(handles.a3_edit,'Enable','on');
        set(handles.a4_edit,'Enable','on');
        set(handles.a5_edit,'Enable','on');
        set(handles.a6_edit,'Enable','on');
        set(handles.b1_edit,'Enable','on');
        set(handles.b2_edit,'Enable','on');
        set(handles.b3_edit,'Enable','on');
        set(handles.b4_edit,'Enable','on');
        set(handles.b5_edit,'Enable','on');
        set(handles.b6_edit,'Enable','on');
        set(handles.A_edit,'Enable','on');
        set(handles.pushbutton_plot,'Enable','on');
end
guidata(hObject,handles)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ------------------------------------------------- %
% --- DISTRIBUTION_PANEL Function Callback     ---- %
% --- Description: Distribution Choice         ---- %
% ------------------------------------------------- %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function distribution_panel_CreateFcn(hObject, eventdata, handles)
function [handles]=distribution_panel_SelectionChangeFcn(hObject, eventdata);
handles=guidata(hObject);
switch get(eventdata.NewValue,'Tag')
    % ------------------------------------------------- %
    % --- RADIOBUTTON_STFT,STFT DISTR.,SPECTOGRAM  ---- %
    % ------------------------------------------------- %
    case 'radiobutton_STFT'

        if get(handles.check_multi,'Value')==1
            set(handles.check_ambiguity,'Visible','on');
            set(handles.check_ambiguity,'Enable','off');
            set(handles.check_ambiguity,'Value',0);
            set(handles.uipanel_ambiguity,'Visible','off');
            set(handles.uipanel4,'Visible','on');

            set(handles.popup_multi1,'Visible','on');
            set(handles.popup_amb,'Visible','off')
        else
            set(handles.edit_LL,'Enable','off');
            set(handles.edit_Lform,'Enable','off');
            set(handles.check_ambiguity,'Visible','off');
        end
        % ------------------------------------------------- %
        % --- RADIOBUTTON_WIGNER, WIGNER DISTRIBUTION  ---- %
        % ------------------------------------------------- %
    case 'radiobutton_wigner'
        if get(handles.check_multi,'Value')==1
            set(handles.check_ambiguity,'Visible','on');
            set(handles.check_ambiguity,'Enable','on');
            set(handles.popup_multi1,'Visible','on');
            set(handles.popup_amb,'Visible','off');
            if get(handles.check_ambiguity,'Value') && get(handles.check_multi,'Value')
                set(popup_multi1,'Visible','off');
                set(popup_amb,'Visible','on')
                switch(handles.popup_amb_val)
                    case 1
                        set(handles.popup_kernel,'Enable','on')
                        switch (handles.kernel_val)
                            case 1
                                handles.const1=1;
                                handles.const2=1/2;
                                set(handles.edit_sigma,'String','150');
                                set(handles.edit_sigma,'Visible','on');
                                set(handles.text59,'Visible','on');
                            case 2
                                handles.const1=2;
                                handles.const2=1;
                                set(handles.edit_sigma,'String','10');
                                set(handles.edit_sigma,'Visible','on');
                                set(handles.text59,'Visible','on');
                            case 3
                                handles.const1=1;
                                handles.const2=1;
                                set(handles.edit_sigma,'String','120');
                                set(handles.edit_sigma,'Visible','on');
                                set(handles.text59,'Visible','on');
                            case 4
                                handles.const1=1;
                                handles.const2=10;
                                set(handles.edit_sigma,'Visible','off');
                                set(handles.text59,'Visible','off');
                        end
                    case 2
                        set(handles.popup_kernel,'Value',1)
                        set(handles.popup_kernel,'Enable','off')
                        set(handles.edit_sigma,'Visible','on');
                        set(handles.text59,'Visible','on');

                        handles.const1=1.5;
                        handles.const2=1;
                        set(handles.edit_sigma,'String','80');
                        set(handles.edit_L,'String','8');

                end
            elseif get(handles.check_multi,'Value')
                set(popup_multi1,'Visible','on');
                set(popup_amb,'Visible','off')
            end
        else
            set(handles.edit_LL,'Enable','off');
            set(handles.edit_Lform,'Enable','off');
            set(handles.check_ambiguity,'Visible','off');
        end
        % ------------------------------------------------- %
        % ---  RADIOBUTTON_LCTD4, CTD4 DISTRIBUTION     ---- %
        % ------------------------------------------------- %
    case 'radiobutton_Lctd4'
        
        if get(handles.check_multi,'Value')==1
            set(handles.check_ambiguity,'Visible','on');
            set(handles.check_ambiguity,'Enable','off');
            set(handles.edit_Lform,'Enable','off');
            set(handles.edit_Lform,'String','')
            set(handles.edit_LL,'String','');
            set(handles.edit_LL,'Enable','off');
        else
            set(handles.edit_Lform,'Enable','on');
            set(handles.edit_Lform,'String','3')
            set(handles.edit_LL,'String','');
            set(handles.edit_LL,'Enable','off');
            set(handles.check_ambiguity,'Visible','off');
        end
        % ------------------------------------------------- %
        % ---  RADIOBUTTON_SM, S Method  DISTRIBUTION  ---- %
        % ------------------------------------------------- %
    case 'radiobutton_sm'
        set(handles.edit_LL,'Enable','on');
        set(handles.edit_LL,'String','12');
        set(handles.edit_Lform,'Enable','off');
        if get(handles.check_multi,'Value')==1
            set(handles.edit_LL,'Enable','off');
            set(handles.edit_Lform,'Enable','off');
            set(handles.check_ambiguity,'Visible','on');
            set(handles.check_ambiguity,'Value',0);
            set(handles.check_ambiguity,'Enable','off');
            set(handles.popup_multi1,'Visible','on');
            set(handles.popup_amb,'Visible','off');
           
        else
            set(handles.check_ambiguity,'Visible','off');
            set(handles.edit_LL,'Enable','on');
        end
        % ------------------------------------------------- %
        % ---  RADIOBUTTON_CTD4, WDC  DISTRIBUTION      ---- %
        % ------------------------------------------------- %
    case 'radiobutton_ctd4'
        set(handles.edit_LL,'Enable','off');
        set(handles.edit_Lform,'Enable','off');
        set(handles.edit_Lform,'String','')
        set(handles.edit_LL,'String','');
        if get(handles.check_multi,'Value')==1
            set(handles.edit_Lform,'Enable','off');
            set(handles.check_ambiguity,'Visible','on');
            set(handles.check_ambiguity,'Enable','on');
            set(handles.edit_L,'String','8');
            switch(handles.popup_amb_val)
                case 1
                    set(handles.popup_kernel,'Enable','on')
                    set(handles.edit_L,'String','8');
                    switch (handles.kernel_val)
                        case 1
                            handles.const1=1;
                            handles.const2=1/2;
                            set(handles.edit_sigma,'String','150');
                            set(handles.edit_sigma,'Visible','on');
                            set(handles.text59,'Visible','on');
                        case 2
                            handles.const1=2;
                            handles.const2=1;
                            set(handles.edit_sigma,'String','10');
                            set(handles.edit_sigma,'Visible','on');
                            set(handles.text59,'Visible','on');
                        case 3
                            handles.const1=1;
                            handles.const2=1;
                            set(handles.edit_sigma,'String','120');
                            set(handles.edit_sigma,'Visible','on');
                            set(handles.text59,'Visible','on');
                        case 4
                            handles.const1=1;
                            handles.const2=10;
                            set(handles.edit_sigma,'Visible','off');
                            set(handles.text59,'Visible','off');
                    end
                case 2
                    set(handles.popup_kernel,'Value',1)
                    set(handles.popup_kernel,'Enable','off')
                    set(handles.edit_sigma,'Visible','on');
                    set(handles.text59,'Visible','on');
                    
                    handles.const1=1.5;
                    handles.const2=1;
                    set(handles.edit_sigma,'String','80');
                    set(handles.edit_L,'String','8');
            end
        else
            set(handles.check_ambiguity,'Visible','off');
            set(handles.edit_Lform,'Enable','off');
        end
        
        % ------------------------------------------------- %
        % ---  RADIOBUTTON_CTD6, SMC  DISTRIBUTION      ---- %
        % ------------------------------------------------- %
    case 'radiobutton_ctd6'
        set(handles.edit_Lform,'Enable','off');
        set(handles.edit_Lform,'String','')
        set(handles.edit_LL,'String','');
        set(handles.edit_LL,'Enable','off');
        if get(handles.check_multi,'Value')==1
            set(handles.edit_Lform,'Enable','off');
            set(handles.edit_L,'String','8');
            if get(handles.radiobutton29,'Value')
                set(handles.check_ambiguity,'Visible','on');
                set(handles.check_ambiguity,'Enable','on');
                
                switch(handles.popup_amb_val)
                    case 1
                        set(handles.popup_kernel,'Enable','on')
                        switch (handles.kernel_val)
                            case 1
                                handles.const1=1;
                                handles.const2=1/2;
                                set(handles.edit_sigma,'String','150');
                                set(handles.edit_sigma,'Visible','on');
                                set(handles.text59,'Visible','on');
                            case 2
                                handles.const1=2;
                                handles.const2=1;
                                set(handles.edit_sigma,'String','10');
                                set(handles.edit_sigma,'Visible','on');
                                set(handles.text59,'Visible','on');
                            case 3
                                handles.const1=1;
                                handles.const2=1;
                                set(handles.edit_sigma,'String','120');
                                set(handles.edit_sigma,'Visible','on');
                                set(handles.text59,'Visible','on');
                            case 4
                                handles.const1=1;
                                handles.const2=10;
                                set(handles.edit_sigma,'Visible','off');
                                set(handles.text59,'Visible','off');
                        end
                    case 2
                        set(handles.popup_kernel,'Value',1)
                        set(handles.popup_kernel,'Enable','off')
                        set(handles.edit_sigma,'Visible','on');
                        set(handles.text59,'Visible','on');

                        handles.const1=1;
                        handles.const2=1/3;
                        set(handles.edit_sigma,'String','150');
                        set(handles.edit_L,'String','12');

                end

            elseif get(handles.radiobutton30,'Value')==1
                set(handles.check_ambiguity,'Visible','on');
                set(handles.check_ambiguity,'Value',1);
                set(handles.check_ambiguity,'Enable','off');
            end
        else
            set(handles.check_ambiguity,'Visible','off');
            set(handles.edit_Lform,'Enable','off');
        end
        % ------------------------------------------------- %
        % ---  RADIOBUTTON_LCTD6, CTD 6  DISTRIBUTION   ---- %
        % ------------------------------------------------- %
    case 'radiobutton_Lctd6'
        set(handles.edit_Lform,'String','3')
        set(handles.edit_Lform,'Enable','on');
        set(handles.edit_LL,'Enable','off');
        if get(handles.check_multi,'Value')==1
            set(handles.check_ambiguity,'Visible','on');
            set(handles.check_ambiguity,'Enable','off');
            set(handles.edit_Lform,'String','')
            set(handles.edit_Lform,'Enable','off');
            set(handles.edit_Lform,'String','')
            set(handles.edit_LL,'Enable','off');
        else
            set(handles.check_ambiguity,'Visible','off');
            set(handles.edit_Lform,'Enable','on');
            set(handles.edit_Lform,'String','3')
            set(handles.edit_LL,'String','');
            set(handles.edit_LL,'Enable','off');
        end
end      
guidata(hObject,handles)

function uipanel32_SelectionChangeFcn(hObject, eventdata, handles)
handles=guidata(hObject);
switch get(eventdata.NewValue,'Tag')
    case 'radiobutton29'
        set(handles.text_signal1,'Visible','on')
        set(handles.text_signal2,'Visible','on')
        set(handles.popup_multi1,'Visible','on')
        set(handles.popup_amb,'Visible','off')
        set(handles.popupmenu15,'Visible','off')
        set(handles.text61,'Visible','off')
        set(handles.check_ambiguity,'Value',0)
        set(handles.check_ambiguity,'Enable','on')
        set(handles.uipanel_ambiguity,'Visible','off');
        set(handles.uipanel4,'Visible','on');
        set(handles.radiobutton_STFT,'Enable','on');
        set(handles.radiobutton_wigner,'Enable','on');
        set(handles.radiobutton_sm,'Enable','on');
        set(handles.compare_check,'Value',0);
        set(handles.popup1m,'Enable','off');
        set(handles.popup2m,'Enable','off');
        set(handles.text56,'Visible','on');
        set(handles.text62,'Visible','off');
        set(handles.text63,'Visible','off');
        set(handles.edit57,'Visible','off');
        set(handles.edit58,'Visible','off');
        set(handles.edit_L,'Visible','on');
        set(handles.edit_multi,'String','128');
        set(handles.edit1,'String',get(handles.edit_multi,'String'));
        set(handles.text75,'Visible','off');
        set(handles.text76,'Visible','off');
        set(handles.popup1m,'Visible','on');
        set(handles.popup2m,'Visible','on');
        set(handles.edit_sigma,'String','150');
    case 'radiobutton30'
        set(handles.text_signal1,'Visible','off')
        set(handles.text_signal2,'Visible','off')
        set(handles.popup_multi1,'Visible','off')
        set(handles.popupmenu15,'Visible','on')
        set(handles.text61,'Visible','on')
        set(handles.radiobutton_Lctd4,'Value',1);
        set(handles.uipanel_ambiguity,'Visible','on');
        set(handles.uipanel_ambiguity,'Visible','on');
        set(handles.check_ambiguity,'Visible','on');
        set(handles.check_ambiguity,'Value',1)
        set(handles.check_ambiguity,'Enable','off');
        set(handles.uipanel4,'Visible','off');
        set(handles.radiobutton_STFT,'Enable','off');
        set(handles.radiobutton_wigner,'Enable','off');
        set(handles.radiobutton_sm,'Enable','off');
        set(handles.radiobutton_ctd4,'Enable','off');
        set(handles.radiobutton_ctd6,'Enable','off');
        set(handles.compare_check,'Value',1);
        set(handles.popup1m,'Enable','on');
        set(handles.popup2m,'Enable','on');
        set(handles.edit_sigma,'String','100');
        set(handles.edit_sigma,'Enable','off');
        set(handles.text56,'Visible','off');
        set(handles.text62,'Visible','on');
        set(handles.text63,'Visible','on');
        set(handles.edit57,'Visible','on');
        set(handles.edit58,'Visible','on');
        set(handles.edit_multi,'String','256');
        set(handles.edit58,'String','16');
        set(handles.edit57,'String','2');
        set(handles.edit57,'Enable','off');
        set(handles.edit58,'Enable','off');
        set(handles.edit_L,'Visible','off');
end
guidata(hObject,handles)

function uipanel34_CreateFcn(hObject, eventdata, handles)

% ------------------------------------------------- %
% --- Pushbutton Function Callback, Create Fcn ---- %
% ------------------------------------------------- %

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ------------------------------------------------- %
% --- Pushbutton1 Function Callback, Create Fcn --- %
% ------------------------------------------------- %
% ---        ---- %
% ------------------------------------------------- %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function [handles]=pushbutton1_Callback(hObject, eventdata, handles);

handles.R=str2double(get(handles.edit2,'String'));
handles.N=str2double(get(handles.edit1,'String'));

handles.signal_width=str2double(get(handles.edit4,'String'));
handles.x_SM=[]; handles.x_WD=[]; handles.x_WDC=[];handles.x_FM=[];
handles.XCCT=[];handles.xapPCC=[];handles.XR=[];handles.SMflauta=[]; handles.SMCflauta=[];handles.SM_speech=[];
handles.specspeech=[];
set(handles.edit59,'String','');
set(handles.edit61,'String','');
set(handles.edit62,'String','');

T=0.25;
handles.t=-(handles.signal_width/2)+2/handles.R:2/handles.R:(handles.signal_width/2);



if get(handles.check_multi,'Value')==1
    handles.variance=15
else
    if get(handles.radiobutton_ctd4,'Value') || get(handles.radiobutton_ctd4,'Value')
        handles.variance=3
    else
        handles.variance=10
    end
end
% ------------------------------------------------- %
% ---             Windows Selection            ---- %
% ------------------------------------------------- %
if handles.val==1
    handles.Ftau=evalin('base',[handles.selectedname,'(',get(handles.edit1,'String'),',',num2str(handles.variance),');']);
else
    handles.Ftau=evalin('base',[handles.selectedname,'(',get(handles.edit1,'String'),');']);
    
end

if get(handles.radiobutton1,'Value')
    [handles.x,handles.diff_x]=signal(handles.t,handles.signal_val);
elseif get(handles.radiobutton2,'Value')
    [handles.x,handles.diff_x]=signal(handles.t,str2double(get(handles.A_edit,'String')),str2double(get(handles.a1_edit,'String')),str2double(get(handles.b1_edit,'String')),str2double(get(handles.a2_edit,'String')),str2double(get(handles.b2_edit,'String')),str2double(get(handles.a3_edit,'String')),str2double( get(handles.b3_edit,'String')),str2double(get(handles.a4_edit,'String')),str2double(get(handles.b4_edit,'String')),str2double(get(handles.a5_edit,'String')),str2double( get(handles.b5_edit,'String')),str2double(get(handles.a6_edit,'String')), str2double(get(handles.b6_edit,'String')));
end
% ------------------------------------------------- %
% ---Selection: Monocomponent,Compare Option   ---- %
% ------------------------------------------------- %
if ~(get(handles.check_multi,'Value'))
    if (get(handles.compare_check,'Value'))
        % ------------------------------------------------- %
        % ---Selecetion: Popup1 Choice                 ---- %
        % ------------------------------------------------- %
        if (handles.popup1_val==1)
            if get(handles.radiobutton1,'Value')
                handles.spec=calculate_STFT(handles.R,handles.Ftau,handles.t,handles.signal_val);
            elseif get(handles.radiobutton2,'Value')
                handles.spec=calculate_STFT_coef(handles.R,handles.Ftau,handles.t,str2double(get(handles.A_edit,'String')),str2double(get(handles.a1_edit,'String')),str2double(get(handles.b1_edit,'String')),str2double(get(handles.a2_edit,'String')),str2double(get(handles.b2_edit,'String')),str2double(get(handles.a3_edit,'String')),str2double(get(handles.b3_edit,'String')),str2double(get(handles.a4_edit,'String')),str2double(get(handles.b4_edit,'String')),str2double(get(handles.a5_edit,'String')),str2double(get(handles.b5_edit,'String')),str2double(get(handles.a6_edit,'String')),str2double(get(handles.b6_edit,'String')));
            end
            handles.a=handles.spec;

        elseif (handles.popup1_val==2)
            if get(handles.radiobutton1,'Value')
                handles.WD=calculate_Wigner(handles.R,handles.Ftau,handles.t,handles.signal_val);
            elseif get(handles.radiobutton2,'Value')
                handles.WD=calculate_Wigner_coef(handles.R,handles.Ftau,handles.t,str2double(get(handles.A_edit,'String')),str2double(get(handles.a1_edit,'String')),str2double(get(handles.b1_edit,'String')),str2double(get(handles.a2_edit,'String')),str2double(get(handles.b2_edit,'String')),str2double(get(handles.a3_edit,'String')),str2double(get(handles.b3_edit,'String')),str2double(get(handles.a4_edit,'String')),str2double(get(handles.b4_edit,'String')),str2double(get(handles.a5_edit,'String')),str2double(get(handles.b5_edit,'String')),str2double(get(handles.a6_edit,'String')),str2double(get(handles.b6_edit,'String')));
            end
            handles.a=abs(handles.WD);

        elseif (handles.popup1_val==3)
            handles.sm_L=str2double(get(handles.edit_LL,'String'));

            if get(handles.radiobutton1,'Value')
                handles.SM=calculate_SM(handles.R,handles.Ftau,handles.sm_L,handles.t,handles.signal_val);

            elseif get(handles.radiobutton2,'Value')
                handles.SM=calculate_SM_coef(handles.R,handles.Ftau,handles.sm_L,handles.t,str2double(get(handles.A_edit,'String')),str2double(get(handles.a1_edit,'String')),str2double(get(handles.b1_edit,'String')),str2double(get(handles.a2_edit,'String')),str2double(get(handles.b2_edit,'String')),str2double(get(handles.a3_edit,'String')),str2double(get(handles.b3_edit,'String')),str2double(get(handles.a4_edit,'String')),str2double(get(handles.b4_edit,'String')),str2double(get(handles.a5_edit,'String')),str2double(get(handles.b5_edit,'String')),str2double(get(handles.a6_edit,'String')),str2double(get(handles.b6_edit,'String')));
            end
            handles.a=abs(handles.SM);

        elseif (handles.popup1_val==4)
            if get(handles.radiobutton1,'Value')
                handles.WDC=calculate_complex_4(handles.R,handles.Ftau,handles.t,handles.signal_val);
            elseif get(handles.radiobutton2,'Value')
                handles.WDC=calculate_complex_4_coef(handles.R,handles.Ftau,handles.t,str2double(get(handles.A_edit,'String')),str2double(get(handles.a1_edit,'String')),str2double(get(handles.b1_edit,'String')),str2double(get(handles.a2_edit,'String')),str2double(get(handles.b2_edit,'String')),str2double(get(handles.a3_edit,'String')),str2double(get(handles.b3_edit,'String')),str2double(get(handles.a4_edit,'String')),str2double(get(handles.b4_edit,'String')),str2double(get(handles.a5_edit,'String')),str2double(get(handles.b5_edit,'String')),str2double(get(handles.a6_edit,'String')),str2double(get(handles.b6_edit,'String')));
            end
            handles.a=abs(handles.WDC);

        elseif (handles.popup1_val==5)
            handles.smc_L=str2double(get(handles.edit_Lform,'String'));

            if get(handles.radiobutton1,'Value')
                handles.SMC=calculate_complex_6(handles.R,handles.Ftau,handles.t,handles.signal_val);
            elseif get(handles.radiobutton2,'Value')
                handles.SMC=calculate_complex_6_coef(handles.R,handles.Ftau,handles.t,str2double(get(handles.A_edit,'String')),str2double(get(handles.a1_edit,'String')),str2double(get(handles.b1_edit,'String')),str2double(get(handles.a2_edit,'String')),str2double(get(handles.b2_edit,'String')),str2double(get(handles.a3_edit,'String')),str2double(get(handles.b3_edit,'String')),str2double(get(handles.a4_edit,'String')),str2double(get(handles.b4_edit,'String')),str2double(get(handles.a5_edit,'String')),str2double(get(handles.b5_edit,'String')),str2double(get(handles.a6_edit,'String')),str2double(get(handles.b6_edit,'String')));
            end
            handles.a=abs(handles.SMC);

        elseif (handles.popup1_val==6)
            handles.ctd4_L=str2double(get(handles.edit_Lform,'String'));
            [handles.LCTD4,handles.CTD4]=calculate_LCTD4(handles.R,handles.Ftau,handles.ctd4_L,handles.t,handles.signal_val)

            if (handles.ctd4_L==1)
                handles.a=abs(handles.CTD4);
            else
                handles.a=abs(handles.LCTD4);
            end
        elseif (handles.popup1_val==7)
            handles.ctd6_L=str2double(get(handles.edit_Lform,'String'));
            [handles.LCTD6,handles.CTD6]=calculate_LCTD6(handles.R,handles.Ftau,handles.ctd6_L,handles.t,handles.signal_val)

            if (handles.ctd6_L==1)
                handles.a=abs(handles.CTD6);
            else
                handles.a=abs(handles.LCTD6);
            end
        end

        axes(handles.axes4)
        pcolor(handles.a),shading interp
        set(handles.axes4,'XMinorTick','on')
        % ------------------------------------------------- %
        % ---Selecetion: Popup2 Choice                 ---- %
        % ------------------------------------------------- %
        if (get(handles.compare_edit,'String')~='1') &(str2double(get(handles.compare_edit,'String'))<=5)
            if (handles.popup2_val==1)
                if get(handles.radiobutton1,'Value')
                    handles.spec=calculate_STFT(handles.R,handles.Ftau,handles.t,handles.signal_val);
                elseif get(handles.radiobutton2,'Value')
                    handles.spec=calculate_STFT_coef(handles.R,handles.Ftau,handles.t,str2double(get(handles.A_edit,'String')),str2double(get(handles.a1_edit,'String')),str2double(get(handles.b1_edit,'String')),str2double(get(handles.a2_edit,'String')),str2double(get(handles.b2_edit,'String')),str2double(get(handles.a3_edit,'String')),str2double(get(handles.b3_edit,'String')),str2double(get(handles.a4_edit,'String')),str2double(get(handles.b4_edit,'String')),str2double(get(handles.a5_edit,'String')),str2double(get(handles.b5_edit,'String')),str2double(get(handles.a6_edit,'String')),str2double(get(handles.b6_edit,'String')));
                end
                handles.b=handles.spec;

            elseif (handles.popup2_val==2)
                if get(handles.radiobutton1,'Value')
                    handles.WD=calculate_Wigner(handles.R,handles.Ftau,handles.t,handles.signal_val);
                elseif get(handles.radiobutton2,'Value')
                    handles.WD=calculate_Wigner_coef(handles.R,handles.Ftau,handles.t,str2double(get(handles.A_edit,'String')),str2double(get(handles.a1_edit,'String')),str2double(get(handles.b1_edit,'String')),str2double(get(handles.a2_edit,'String')),str2double(get(handles.b2_edit,'String')),str2double(get(handles.a3_edit,'String')),str2double(get(handles.b3_edit,'String')),str2double(get(handles.a4_edit,'String')),str2double(get(handles.b4_edit,'String')),str2double(get(handles.a5_edit,'String')),str2double(get(handles.b5_edit,'String')),str2double(get(handles.a6_edit,'String')),str2double(get(handles.b6_edit,'String')));
                end
                handles.b=abs(handles.WD);

            elseif (handles.popup2_val==3)
                handles.sm_L=str2double(get(handles.edit_LL,'String'));

                if get(handles.radiobutton1,'Value')
                    handles.SM=calculate_SM(handles.R,handles.Ftau,handles.sm_L,handles.t,handles.signal_val);
                elseif get(handles.radiobutton2,'Value')
                    handles.SM=calculate_SM_coef(handles.R,handles.Ftau,handles.sm_L,handles.t,str2double(get(handles.A_edit,'String')),str2double(get(handles.a1_edit,'String')),str2double(get(handles.b1_edit,'String')),str2double(get(handles.a2_edit,'String')),str2double(get(handles.b2_edit,'String')),str2double(get(handles.a3_edit,'String')),str2double(get(handles.b3_edit,'String')),str2double(get(handles.a4_edit,'String')),str2double(get(handles.b4_edit,'String')),str2double(get(handles.a5_edit,'String')),str2double(get(handles.b5_edit,'String')),str2double(get(handles.a6_edit,'String')),str2double(get(handles.b6_edit,'String')));
                end
                handles.b=abs(handles.SM);

            elseif (handles.popup2_val==4)
                if get(handles.radiobutton1,'Value')
                    handles.WDC=calculate_complex_4(handles.R,handles.Ftau,handles.t,handles.signal_val);
                elseif get(handles.radiobutton2,'Value')
                    handles.WDC=calculate_complex_4_coef(handles.R,handles.Ftau,handles.t,str2double(get(handles.A_edit,'String')),str2double(get(handles.a1_edit,'String')),str2double(get(handles.b1_edit,'String')),str2double(get(handles.a2_edit,'String')),str2double(get(handles.b2_edit,'String')),str2double(get(handles.a3_edit,'String')),str2double(get(handles.b3_edit,'String')),str2double(get(handles.a4_edit,'String')),str2double(get(handles.b4_edit,'String')),str2double(get(handles.a5_edit,'String')),str2double(get(handles.b5_edit,'String')),str2double(get(handles.a6_edit,'String')),str2double(get(handles.b6_edit,'String')));
                end
                handles.b=abs(handles.WDC);

            elseif (handles.popup2_val==5)
                if get(handles.radiobutton1,'Value')
                    handles.SMC=calculate_complex_6(handles.R,handles.Ftau,handles.t,handles.signal_val);
                elseif get(handles.radiobutton2,'Value')
                    handles.SMC=calculate_complex_6_coef(handles.R,handles.Ftau,handles.t,str2double(get(handles.A_edit,'String')),str2double(get(handles.a1_edit,'String')),str2double(get(handles.b1_edit,'String')),str2double(get(handles.a2_edit,'String')),str2double(get(handles.b2_edit,'String')),str2double(get(handles.a3_edit,'String')),str2double(get(handles.b3_edit,'String')),str2double(get(handles.a4_edit,'String')),str2double(get(handles.b4_edit,'String')),str2double(get(handles.a5_edit,'String')),str2double(get(handles.b5_edit,'String')),str2double(get(handles.a6_edit,'String')),str2double(get(handles.b6_edit,'String')));
                end
                handles.b=abs(handles.SMC);

            elseif (handles.popup2_val==6)
                handles.ctd4_L=str2double(get(handles.edit_Lform,'String'));
                [handles.LCTD4,handles.CTD4]=calculate_LCTD4(handles.R,handles.Ftau,handles.ctd4_L,handles.t,handles.signal_val)

                if (handles.ctd4_L==1)
                    handles.b=abs(handles.CTD4);
                else
                    handles.b=abs(handles.LCTD4);
                end

            elseif (handles.popup2_val==7)
                handles.ctd6_L=str2double(get(handles.edit_Lform,'String'));
                [handles.LCTD6,handles.CTD6]=calculate_LCTD6(handles.R,handles.Ftau,handles.ctd6_L,handles.t,handles.signal_val)

                if (handles.ctd6_L==1)
                    handles.b=abs(handles.CTD6);
                else
                    handles.b=abs(handles.LCTD6);
                end
            end
            axes(handles.axes5)
            pcolor(handles.b),shading interp
            set(handles.axes5,'XMinorTick','on')
        end
        % ------------------------------------------------- %
        % ---Selecetion: Popup3 Choice                 ---- %
        % ------------------------------------------------- %
        if (str2double(get(handles.compare_edit,'String'))>2) &(str2double(get(handles.compare_edit,'String'))<=5)

            if (handles.popup3_val==1)

                if get(handles.radiobutton1,'Value')
                    handles.spec=calculate_STFT(handles.R,handles.Ftau,handles.t,handles.signal_val);
                elseif get(handles.radiobutton2,'Value')
                    handles.spec=calculate_STFT_coef(handles.R,handles.Ftau,handles.t,str2double(get(handles.A_edit,'String')),str2double(get(handles.a1_edit,'String')),str2double(get(handles.b1_edit,'String')),str2double(get(handles.a2_edit,'String')),str2double(get(handles.b2_edit,'String')),str2double(get(handles.a3_edit,'String')),str2double(get(handles.b3_edit,'String')),str2double(get(handles.a4_edit,'String')),str2double(get(handles.b4_edit,'String')),str2double(get(handles.a5_edit,'String')),str2double(get(handles.b5_edit,'String')),str2double(get(handles.a6_edit,'String')),str2double(get(handles.b6_edit,'String')));
                end
                handles.c=(handles.spec);

            elseif (handles.popup3_val==2)
                if get(handles.radiobutton1,'Value')
                    handles.WD=calculate_Wigner(handles.R,handles.Ftau,handles.t,handles.signal_val);
                elseif get(handles.radiobutton2,'Value')
                    handles.WD=calculate_Wigner_coef(handles.R,handles.Ftau,handles.t,str2double(get(handles.A_edit,'String')),str2double(get(handles.a1_edit,'String')),str2double(get(handles.b1_edit,'String')),str2double(get(handles.a2_edit,'String')),str2double(get(handles.b2_edit,'String')),str2double(get(handles.a3_edit,'String')),str2double(get(handles.b3_edit,'String')),str2double(get(handles.a4_edit,'String')),str2double(get(handles.b4_edit,'String')),str2double(get(handles.a5_edit,'String')),str2double(get(handles.b5_edit,'String')),str2double(get(handles.a6_edit,'String')),str2double(get(handles.b6_edit,'String')));
                end
                handles.c=abs(handles.WD);

            elseif (handles.popup3_val==3)
                handles.sm_L=str2double(get(handles.edit_LL,'String'));
                if get(handles.radiobutton1,'Value')
                    handles.SM=calculate_SM(handles.R,handles.Ftau,handles.sm_L,handles.t,handles.signal_val);
                elseif get(handles.radiobutton2,'Value')
                    handles.SM=calculate_SM_coef(handles.R,handles.Ftau,handles.sm_L,handles.t,str2double(get(handles.A_edit,'String')),str2double(get(handles.a1_edit,'String')),str2double(get(handles.b1_edit,'String')),str2double(get(handles.a2_edit,'String')),str2double(get(handles.b2_edit,'String')),str2double(get(handles.a3_edit,'String')),str2double(get(handles.b3_edit,'String')),str2double(get(handles.a4_edit,'String')),str2double(get(handles.b4_edit,'String')),str2double(get(handles.a5_edit,'String')),str2double(get(handles.b5_edit,'String')),str2double(get(handles.a6_edit,'String')),str2double(get(handles.b6_edit,'String')));
                end
                handles.c=abs(handles.SM);

            elseif (handles.popup3_val==4)
                if get(handles.radiobutton1,'Value')
                    handles.WDC=calculate_complex_4(handles.R,handles.Ftau,handles.t,handles.signal_val);
                elseif get(handles.radiobutton2,'Value')
                    handles.WDC=calculate_complex_4_coef(handles.R,handles.Ftau,handles.t,str2double(get(handles.A_edit,'String')),str2double(get(handles.a1_edit,'String')),str2double(get(handles.b1_edit,'String')),str2double(get(handles.a2_edit,'String')),str2double(get(handles.b2_edit,'String')),str2double(get(handles.a3_edit,'String')),str2double(get(handles.b3_edit,'String')),str2double(get(handles.a4_edit,'String')),str2double(get(handles.b4_edit,'String')),str2double(get(handles.a5_edit,'String')),str2double(get(handles.b5_edit,'String')),str2double(get(handles.a6_edit,'String')),str2double(get(handles.b6_edit,'String')));
                end
                handles.c=abs(handles.WDC);

            elseif (handles.popup3_val==5)
                
                if get(handles.radiobutton1,'Value')
                    handles.SMC=calculate_complex_6(handles.R,handles.Ftau,handles.t,handles.signal_val);
                elseif get(handles.radiobutton2,'Value')
                    handles.SMC=calculate_complex_6_coef(handles.R,handles.Ftau,handles.t,str2double(get(handles.A_edit,'String')),str2double(get(handles.a1_edit,'String')),str2double(get(handles.b1_edit,'String')),str2double(get(handles.a2_edit,'String')),str2double(get(handles.b2_edit,'String')),str2double(get(handles.a3_edit,'String')),str2double(get(handles.b3_edit,'String')),str2double(get(handles.a4_edit,'String')),str2double(get(handles.b4_edit,'String')),str2double(get(handles.a5_edit,'String')),str2double(get(handles.b5_edit,'String')),str2double(get(handles.a6_edit,'String')),str2double(get(handles.b6_edit,'String')));
                end
                handles.c=abs(handles.SMC);

            elseif (handles.popup3_val==6)
                handles.ctd4_L=str2double(get(handles.edit_Lform,'String'));
                [handles.LCTD4,handles.CTD4]=calculate_LCTD4(handles.R,handles.Ftau,handles.ctd4_L,handles.t,handles.signal_val)

                if (handles.ctd4_L==1)
                    handles.c=abs(handles.CTD4);
                else
                    handles.c=abs(handles.LCTD4);
                end

            elseif (handles.popup3_val==7)
                handles.ctd6_L=str2double(get(handles.edit_Lform,'String'));
                [handles.LCTD6,handles.CTD6]=calculate_LCTD6(handles.R,handles.Ftau,handles.ctd6_L,handles.t,handles.signal_val)

                if (handles.ctd6_L==1)
                    handles.c=abs(handles.CTD6);
                else
                    handles.c=abs(handles.LCTD6);
                end
            end
            axes(handles.axes6)
            pcolor(abs(handles.c)),shading interp
            set(handles.axes6,'XMinorTick','on')
        end
        % ------------------------------------------------- %
        % ---Selecetion: Popup4 Choice                 ---- %
        % ------------------------------------------------- %
        if (str2double(get(handles.compare_edit,'String'))==4)

            if (handles.popup4_val==1)

                if get(handles.radiobutton1,'Value')
                    handles.spec=calculate_STFT(handles.R,handles.Ftau,handles.t,handles.signal_val);
                elseif get(handles.radiobutton2,'Value')
                    handles.spec=calculate_STFT_coef(handles.R,handles.Ftau,handles.t,str2double(get(handles.A_edit,'String')),str2double(get(handles.a1_edit,'String')),str2double(get(handles.b1_edit,'String')),str2double(get(handles.a2_edit,'String')),str2double(get(handles.b2_edit,'String')),str2double(get(handles.a3_edit,'String')),str2double(get(handles.b3_edit,'String')),str2double(get(handles.a4_edit,'String')),str2double(get(handles.b4_edit,'String')),str2double(get(handles.a5_edit,'String')),str2double(get(handles.b5_edit,'String')),str2double(get(handles.a6_edit,'String')),str2double(get(handles.b6_edit,'String')));
                end
                handles.d=(handles.spec);

            elseif (handles.popup4_val==2)
                if get(handles.radiobutton1,'Value')
                    handles.WD=calculate_Wigner(handles.R,handles.Ftau,handles.t,handles.signal_val);
                elseif get(handles.radiobutton2,'Value')
                    handles.WD=calculate_Wigner_coef(handles.R,handles.Ftau,handles.t,str2double(get(handles.A_edit,'String')),str2double(get(handles.a1_edit,'String')),str2double(get(handles.b1_edit,'String')),str2double(get(handles.a2_edit,'String')),str2double(get(handles.b2_edit,'String')),str2double(get(handles.a3_edit,'String')),str2double(get(handles.b3_edit,'String')),str2double(get(handles.a4_edit,'String')),str2double(get(handles.b4_edit,'String')),str2double(get(handles.a5_edit,'String')),str2double(get(handles.b5_edit,'String')),str2double(get(handles.a6_edit,'String')),str2double(get(handles.b6_edit,'String')));
                end
                handles.d=abs(handles.WD);

            elseif (handles.popup4_val==3)
                handles.sm_L=str2double(get(handles.edit_LL,'String'));

                if get(handles.radiobutton1,'Value')
                    handles.SM=calculate_SM(handles.R,handles.Ftau,handles.sm_L,handles.t,handles.signal_val);
                elseif get(handles.radiobutton2,'Value')
                    handles.SM=calculate_SM_coef(handles.R,handles.Ftau,handles.sm_L,handles.t,str2double(get(handles.A_edit,'String')),str2double(get(handles.a1_edit,'String')),str2double(get(handles.b1_edit,'String')),str2double(get(handles.a2_edit,'String')),str2double(get(handles.b2_edit,'String')),str2double(get(handles.a3_edit,'String')),str2double(get(handles.b3_edit,'String')),str2double(get(handles.a4_edit,'String')),str2double(get(handles.b4_edit,'String')),str2double(get(handles.a5_edit,'String')),str2double(get(handles.b5_edit,'String')),str2double(get(handles.a6_edit,'String')),str2double(get(handles.b6_edit,'String')));
                end
                handles.d=abs(handles.SM);

            elseif (handles.popup4_val==4)
                if get(handles.radiobutton1,'Value')
                    handles.WDC=calculate_complex_4(handles.R,handles.Ftau,handles.t,handles.signal_val);
                elseif get(handles.radiobutton2,'Value')
                    handles.WDC=calculate_complex_4_coef(handles.R,handles.Ftau,handles.t,str2double(get(handles.A_edit,'String')),str2double(get(handles.a1_edit,'String')),str2double(get(handles.b1_edit,'String')),str2double(get(handles.a2_edit,'String')),str2double(get(handles.b2_edit,'String')),str2double(get(handles.a3_edit,'String')),str2double(get(handles.b3_edit,'String')),str2double(get(handles.a4_edit,'String')),str2double(get(handles.b4_edit,'String')),str2double(get(handles.a5_edit,'String')),str2double(get(handles.b5_edit,'String')),str2double(get(handles.a6_edit,'String')),str2double(get(handles.b6_edit,'String')));
                end
                handles.d=abs(handles.WDC);

            elseif (handles.popup4_val==5)
            
                if get(handles.radiobutton1,'Value')
                    handles.SMC=calculate_complex_6(handles.R,handles.Ftau,handles.t,handles.signal_val);
                elseif get(handles.radiobutton2,'Value')
                    handles.SMC=calculate_complex_6_coef(handles.R,handles.Ftau,handles.t,str2double(get(handles.A_edit,'String')),str2double(get(handles.a1_edit,'String')),str2double(get(handles.b1_edit,'String')),str2double(get(handles.a2_edit,'String')),str2double(get(handles.b2_edit,'String')),str2double(get(handles.a3_edit,'String')),str2double(get(handles.b3_edit,'String')),str2double(get(handles.a4_edit,'String')),str2double(get(handles.b4_edit,'String')),str2double(get(handles.a5_edit,'String')),str2double(get(handles.b5_edit,'String')),str2double(get(handles.a6_edit,'String')),str2double(get(handles.b6_edit,'String')));
                end
                handles.d=abs(handles.SMC);

            elseif (handles.popup4_val==6)
                handles.ctd4_L=str2double(get(handles.edit_Lform,'String'));
                [handles.LCTD4,handles.CTD4]=calculate_LCTD4(handles.R,handles.Ftau,handles.ctd4_L,handles.t,handles.signal_val)

                if (handles.ctd4_L==1)
                    handles.d=abs(handles.CTD4);
                else
                    handles.d=abs(handles.LCTD4);
                end

            elseif (handles.popup4_val==7)
                handles.ctd6_L=str2double(get(handles.edit_Lform,'String'));
                [handles.LCTD6,handles.CTD6]=calculate_LCTD6(handles.R,handles.Ftau,handles.ctd6_L,handles.t,handles.signal_val)

                if (handles.ctd6_L==1)
                    handles.d=abs(handles.CTD6);
                else
                    handles.d=abs(handles.LCTD6);
                end
            end

            axes(handles.axes7)
            pcolor(abs(handles.d)),shading interp
            set(handles.axes7,'XMinorTick','on')
        end
        % ------------------------------------------------- %
        % ---Selecetion: MSE Calculation               ---- %
        % -------In case of Compare Option Disabled-------- %
        % ------------------------------------------------- %
    elseif get(handles.checkbox_mse,'Value')
        handles.Ftau=1;
        if get(handles.radiobutton1,'Value')
            handles.WD=calculate_Wigner(handles.R,handles.Ftau,handles.t,handles.signal_val);
        elseif get(handles.radiobutton2,'Value')
            handles.WD=calculate_Wigner_coef(handles.R,handles.Ftau,handles.t,str2double(get(handles.A_edit,'String')),str2double(get(handles.a1_edit,'String')),str2double(get(handles.b1_edit,'String')),str2double(get(handles.a2_edit,'String')),str2double(get(handles.b2_edit,'String')),str2double(get(handles.a3_edit,'String')),str2double(get(handles.b3_edit,'String')),str2double(get(handles.a4_edit,'String')),str2double(get(handles.b4_edit,'String')),str2double(get(handles.a5_edit,'String')),str2double(get(handles.b5_edit,'String')),str2double(get(handles.a6_edit,'String')),str2double(get(handles.b6_edit,'String')));
        end
        % ------------------------------------------------- %
        % ---Selecetion: MSE Calculation               ---- %
        % -------Wigner Distribution                   ---- %
        % ------------------------------------------------- %
        handles.matrica=abs(handles.WD);
        handles.diff=handles.diff_x;
        handles.ms_error=mse(handles.matrica,handles.diff);
        set(handles.edit59,'String',num2str(handles.ms_error));
        if handles.ms_error<str2double(get(handles.edit63,'String'))
            axes(handles.axes1)
            pcolor(abs(handles.WD)),shading interp
            set(handles.axes1,'XMinorTick','on')
            set(handles.text71,'String','OK');
        else
            axes(handles.axes4)
            pcolor(abs(handles.WD)),shading interp
            set(handles.axes1,'XMinorTick','on')
            set(handles.text75,'Visible','on');
            set(handles.popup1,'Visible','off');
            set(handles.popup1m,'Visible','off');
            set(handles.text75,'String','Wigner distribution, MSE not satisfactory');
            set(handles.text71,'String','NO');
            handles.ctd4_L=str2double(get(handles.edit_Lform,'String'));
            if get(handles.radiobutton1,'Value')
                handles.CTD4=calculate_complex_4(handles.R,handles.Ftau,handles.t,handles.signal_val)
            else
                handles.CTD4=calculate_complex_4_coef(handles.R,handles.Ftau,handles.t,str2double(get(handles.A_edit,'String')),str2double(get(handles.a1_edit,'String')),str2double(get(handles.b1_edit,'String')),str2double(get(handles.a2_edit,'String')),str2double(get(handles.b2_edit,'String')),str2double(get(handles.a3_edit,'String')),str2double(get(handles.b3_edit,'String')),str2double(get(handles.a4_edit,'String')),str2double(get(handles.b4_edit,'String')),str2double(get(handles.a5_edit,'String')),str2double(get(handles.b5_edit,'String')),str2double(get(handles.a6_edit,'String')),str2double(get(handles.b6_edit,'String')));
            end
            % ------------------------------------------------- %
            % ---Selecetion: MSE Calculation               ---- %
            % -------CTD 4                                 ---- %
            % ------------------------------------------------- %
                handles.matrica=abs(handles.CTD4);
                handles.diff=handles.diff_x;
                [handles.ms_error,handles.aprox]=mse(handles.matrica,handles.diff);
                set(handles.edit61,'String',num2str(handles.ms_error));

                axes(handles.axes3)
                plot(handles.t, handles.aprox,handles.t, handles.diff_x,'r')
                set(handles.axes3,'XMinorTick','on')
                set(handles.text77,'String','CTD4, MSE < DESIRED MSE');

           if handles.ms_error<str2double(get(handles.edit63,'String'))

                axes(handles.axes1)
                pcolor(abs(handles.CTD4)),shading interp
                set(handles.axes1,'XMinorTick','on')
                set(handles.text72,'String','OK');
           else
                axes(handles.axes5)
                pcolor(abs(handles.CTD4)),shading interp
                set(handles.axes5,'XMinorTick','on')
                set(handles.text76,'Visible','on');
                set(handles.popup2,'Visible','off');
                set(handles.popup2m,'Visible','off');
                set(handles.text76,'String','CTD4 distribution, MSE not satisfactory');
                set(handles.text72,'String','NO');
                handles.ctd6_L=str2double(get(handles.edit_Lform,'String'));

                if get(handles.radiobutton1,'Value')
                    handles.CTD6=calculate_complex_6(handles.R,handles.Ftau,handles.t,handles.signal_val);
                else
                    handles.CTD6=calculate_complex_6_coef(handles.R,handles.Ftau,handles.t,str2double(get(handles.A_edit,'String')),str2double(get(handles.a1_edit,'String')),str2double(get(handles.b1_edit,'String')),str2double(get(handles.a2_edit,'String')),str2double(get(handles.b2_edit,'String')),str2double(get(handles.a3_edit,'String')),str2double(get(handles.b3_edit,'String')),str2double(get(handles.a4_edit,'String')),str2double(get(handles.b4_edit,'String')),str2double(get(handles.a5_edit,'String')),str2double(get(handles.b5_edit,'String')),str2double(get(handles.a6_edit,'String')),str2double(get(handles.b6_edit,'String')));
                end

                % ------------------------------------------------- %
                % ---Selecetion: MSE Calculation               ---- %
                % -------CTD 6                                 ---- %
                % ------------------------------------------------- %

                axes(handles.axes1)
                pcolor(abs(handles.CTD6)),shading interp
                set(handles.axes1,'XMinorTick','on')

                handles.matrica=abs(handles.CTD6);
                [handles.ms_error,handles.aprox]=mse(handles.matrica,handles.diff_x);
                set(handles.edit62,'String',num2str(handles.ms_error));

                axes(handles.axes3)
                plot(handles.t, handles.aprox,handles.t, handles.diff_x,'r')
                set(handles.axes3,'XMinorTick','on')
                set(handles.text77,'String','CTD6, MSE < DESIRED MSE');
                    % ------------------------------------------------- %
                    % ---Selecetion: MSE Calculation               ---- %
                    % -------LCTD 6                                ---- %
                    % ------------------------------------------------- %

                if handles.ms_error<str2double(get(handles.edit63,'String'))
                    set(handles.text73,'String','OK');
                    axes(handles.axes1)
                    pcolor(abs(handles.CTD6)),shading interp
                    set(handles.axes1,'XMinorTick','on')
                    set(handles.text77,'String','CTD6, MSE < DESIRED MSE');
                else
                    set(handles.text73,'String','NO');
                    set(handles.text77,'String','');
                    axes(handles.axes6)
                    pcolor(abs(handles.CTD6)),shading interp
                    set(handles.axes6,'XMinorTick','on')
                    set(handles.text78,'Visible','on');
                    set(handles.popup2,'Visible','off');
                    set(handles.popup2m,'Visible','off');
                    set(handles.text78,'String','CTD6 distribution, MSE not satisfactory');
                end
            end
        end
    elseif get(handles.checkbox_conc,'Value')
        handles.Ftau=1;
        if get(handles.radiobutton1,'Value')
            handles.WD=calculate_Wigner(handles.R,handles.Ftau,handles.t,handles.signal_val);
        elseif get(handles.radiobutton2,'Value')
            handles.WD=calculate_Wigner_coef(handles.R,handles.Ftau,handles.t,str2double(get(handles.A_edit,'String')),str2double(get(handles.a1_edit,'String')),str2double(get(handles.b1_edit,'String')),str2double(get(handles.a2_edit,'String')),str2double(get(handles.b2_edit,'String')),str2double(get(handles.a3_edit,'String')),str2double(get(handles.b3_edit,'String')),str2double(get(handles.a4_edit,'String')),str2double(get(handles.b4_edit,'String')),str2double(get(handles.a5_edit,'String')),str2double(get(handles.b5_edit,'String')),str2double(get(handles.a6_edit,'String')),str2double(get(handles.b6_edit,'String')));
        end
        % ------------------------------------------------- %
        % ---Selection: Concentration Measure Calculation-- %
        % -------Wigner Distribution                   ---- %
        % ------------------------------------------------- %
        handles.cmeasure=ConcentrationMeasure(handles.WD);
        set(handles.edit59,'String',num2str(handles.cmeasure));
        if handles.cmeasure>str2double(get(handles.edit63,'String'))
            axes(handles.axes1)
            pcolor(abs(handles.WD)),shading interp
            set(handles.axes1,'XMinorTick','on')
            set(handles.text71,'String','OK');
        else
            axes(handles.axes4)
            pcolor(abs(handles.WD)),shading interp
            set(handles.axes1,'XMinorTick','on')
            set(handles.text75,'Visible','on');
            set(handles.popup1,'Visible','off');
            set(handles.popup1m,'Visible','off');
            set(handles.text75,'String','Wigner distribution, M not satisfactory');
            set(handles.text71,'String','NO');
            handles.ctd4_L=str2double(get(handles.edit_Lform,'String'));

            if get(handles.radiobutton1,'Value')
                handles.CTD4=calculate_complex_4(handles.R,handles.Ftau,handles.t,handles.signal_val)
            else
                handles.CTD4=calculate_complex_4_coef(handles.R,handles.Ftau,handles.t,str2double(get(handles.A_edit,'String')),str2double(get(handles.a1_edit,'String')),str2double(get(handles.b1_edit,'String')),str2double(get(handles.a2_edit,'String')),str2double(get(handles.b2_edit,'String')),str2double(get(handles.a3_edit,'String')),str2double(get(handles.b3_edit,'String')),str2double(get(handles.a4_edit,'String')),str2double(get(handles.b4_edit,'String')),str2double(get(handles.a5_edit,'String')),str2double(get(handles.b5_edit,'String')),str2double(get(handles.a6_edit,'String')),str2double(get(handles.b6_edit,'String')));
            end
            % ------------------------------------------------- %
            % ---Selecetion:Concentration Measure          ---- %
            % -------CTD 4                                 ---- %
            % ------------------------------------------------- %
            handles.cmeasure=ConcentrationMeasure(handles.CTD4);
            set(handles.edit61,'String',num2str(handles.cmeasure));

            if handles.cmeasure>str2double(get(handles.edit63,'String'))
                set(handles.text77,'String','CTD4, M > DESIRED MSE');
                axes(handles.axes1)
                pcolor(abs(handles.CTD4)),shading interp
                set(handles.axes1,'XMinorTick','on')
                set(handles.text72,'String','OK');
            else
                axes(handles.axes5)
                pcolor(abs(handles.CTD4)),shading interp
                set(handles.axes5,'XMinorTick','on')
                set(handles.text76,'Visible','on');
                set(handles.popup2,'Visible','off');
                set(handles.popup2m,'Visible','off');
                set(handles.text76,'String','CTD4 distribution, M not satisfactory');
                set(handles.text72,'String','NO');

                if get(handles.radiobutton1,'Value')
                    handles.CTD6=calculate_complex_6(handles.R,handles.Ftau,handles.t,handles.signal_val);
                else
                    handles.CTD6=calculate_complex_6_coef(handles.R,handles.Ftau,handles.t,str2double(get(handles.A_edit,'String')),str2double(get(handles.a1_edit,'String')),str2double(get(handles.b1_edit,'String')),str2double(get(handles.a2_edit,'String')),str2double(get(handles.b2_edit,'String')),str2double(get(handles.a3_edit,'String')),str2double(get(handles.b3_edit,'String')),str2double(get(handles.a4_edit,'String')),str2double(get(handles.b4_edit,'String')),str2double(get(handles.a5_edit,'String')),str2double(get(handles.b5_edit,'String')),str2double(get(handles.a6_edit,'String')),str2double(get(handles.b6_edit,'String')));
                end
                % ------------------------------------------------- %
                % ---Selecetion: Concentration Measure         ---- %
                % -------CTD 6                                 ---- %
                % ------------------------------------------------- %
                handles.cmeasure=ConcentrationMeasure(handles.CTD6);
                set(handles.edit62,'String',num2str(handles.cmeasure));
                
                if handles.cmeasure>str2double(get(handles.edit63,'String'))

                    axes(handles.axes1)
                    pcolor(abs(handles.CTD6)),shading interp
                    set(handles.axes1,'XMinorTick','on')
                    set(handles.text73,'String','OK');
                    set(handles.text77,'String','CTD6 distribution, M > Desired M');
                else
                    axes(handles.axes6)
                    pcolor(abs(handles.CTD6)),shading interp
                    set(handles.axes1,'XMinorTick','on')
                    set(handles.text75,'Visible','on');
                    set(handles.popup1,'Visible','off');
                    set(handles.popup1m,'Visible','off');
                    set(handles.text75,'String','CTD6 distribution, M not satisfactory');
                    set(handles.text73,'String','NO');
                    handles.ctd4_L=str2double(get(handles.edit_Lform,'String'));
                end  
            end
        end
        % ------------------------------------------------- %
        % --- Selection:                               ---- %
        % --- Monocomponent, Disabled Compare Option   ---- %
        % ------------------------------------------------- %
    else
        if get(handles.radiobutton_STFT,'Value')

            if get(handles.radiobutton1,'Value')
                handles.spec=calculate_STFT(handles.R,handles.Ftau,handles.t,handles.signal_val);
                set(handles.edit3,'String',get(handles.edit2,'String'));
                set(handles.edit3,'String','1');
            elseif get(handles.radiobutton2,'Value')
                handles.spec=calculate_STFT_coef(handles.R,handles.Ftau,handles.t,str2double(get(handles.A_edit,'String')),str2double(get(handles.a1_edit,'String')),str2double(get(handles.b1_edit,'String')),str2double(get(handles.a2_edit,'String')),str2double(get(handles.b2_edit,'String')),str2double(get(handles.a3_edit,'String')),str2double(get(handles.b3_edit,'String')),str2double(get(handles.a4_edit,'String')),str2double(get(handles.b4_edit,'String')),str2double(get(handles.a5_edit,'String')),str2double(get(handles.b5_edit,'String')),str2double(get(handles.a6_edit,'String')),str2double(get(handles.b6_edit,'String')));
            end

            axes(handles.axes1)
            pcolor(handles.spec),shading interp
            set(handles.axes1,'XMinorTick','on')

            % ------------------------------------------------- %
            % --- Selection:                               ---- %
            % --- Monocomponent Wigner                     ---- %
            % ------------------------------------------------- %
        elseif get(handles.radiobutton_wigner,'Value')
            if get(handles.radiobutton1,'Value')
                handles.WD=calculate_Wigner(handles.R,handles.Ftau,handles.t,handles.signal_val);

            elseif get(handles.radiobutton2,'Value')
                handles.WD=calculate_Wigner_coef(handles.R,handles.Ftau,handles.t,str2double(get(handles.A_edit,'String')),str2double(get(handles.a1_edit,'String')),str2double(get(handles.b1_edit,'String')),str2double(get(handles.a2_edit,'String')),str2double(get(handles.b2_edit,'String')),str2double(get(handles.a3_edit,'String')),str2double(get(handles.b3_edit,'String')),str2double(get(handles.a4_edit,'String')),str2double(get(handles.b4_edit,'String')),str2double(get(handles.a5_edit,'String')),str2double(get(handles.b5_edit,'String')),str2double(get(handles.a6_edit,'String')),str2double(get(handles.b6_edit,'String')));

            end

            axes(handles.axes1)
            pcolor(abs(handles.WD)),shading interp
            set(handles.axes1,'XMinorTick','on')

            % ------------------------------------------------- %
            % --- Selection:                               ---- %
            % --- Monocomponent S Method                   ---- %
            % ------------------------------------------------- %
        elseif get(handles.radiobutton_sm,'Value')
            handles.sm_L=str2double(get(handles.edit_LL,'String'));
            set(handles.edit_LL,'Enable','on');

            if get(handles.radiobutton1,'Value')
                handles.SM=calculate_SM(handles.R,handles.Ftau,handles.sm_L,handles.t,handles.signal_val);

            elseif get(handles.radiobutton2,'Value')
                handles.SM=calculate_SM_coef(handles.R,handles.Ftau,handles.sm_L,handles.t,str2double(get(handles.A_edit,'String')),str2double(get(handles.a1_edit,'String')),str2double(get(handles.b1_edit,'String')),str2double(get(handles.a2_edit,'String')),str2double(get(handles.b2_edit,'String')),str2double(get(handles.a3_edit,'String')),str2double(get(handles.b3_edit,'String')),str2double(get(handles.a4_edit,'String')),str2double(get(handles.b4_edit,'String')),str2double(get(handles.a5_edit,'String')),str2double(get(handles.b5_edit,'String')),str2double(get(handles.a6_edit,'String')),str2double(get(handles.b6_edit,'String')));

            end
            axes(handles.axes1)
            pcolor(abs(handles.SM)),shading interp
            set(handles.axes1,'XMinorTick','on')

            % ------------------------------------------------- %
            % --- Selection:                               ---- %
            % --- Monocomponent WDC                        ---- %
            % ------------------------------------------------- %
        elseif    get(handles.radiobutton_ctd4,'Value')

            if get(handles.radiobutton1,'Value')
                handles.WDC=calculate_complex_4(handles.R,handles.Ftau,handles.t,handles.signal_val);

            elseif get(handles.radiobutton2,'Value')
                handles.WDC=calculate_complex_4_coef(handles.R,handles.Ftau,handles.t,str2double(get(handles.A_edit,'String')),str2double(get(handles.a1_edit,'String')),str2double(get(handles.b1_edit,'String')),str2double(get(handles.a2_edit,'String')),str2double(get(handles.b2_edit,'String')),str2double(get(handles.a3_edit,'String')),str2double(get(handles.b3_edit,'String')),str2double(get(handles.a4_edit,'String')),str2double(get(handles.b4_edit,'String')),str2double(get(handles.a5_edit,'String')),str2double(get(handles.b5_edit,'String')),str2double(get(handles.a6_edit,'String')),str2double(get(handles.b6_edit,'String')));

            end

            axes(handles.axes1)
            pcolor(abs(handles.WDC)),shading interp
            set(handles.axes1,'XMinorTick','on')

            % ------------------------------------------------- %
            % --- Selection:                               ---- %
            % --- Monocomponent SMC                        ---- %
            % ------------------------------------------------- %
        elseif   get(handles.radiobutton_ctd6,'Value')
            if get(handles.radiobutton1,'Value')
                handles.SMC=calculate_complex_6(handles.R,handles.Ftau,handles.t,handles.signal_val);
            elseif get(handles.radiobutton2,'Value')
                handles.SMC=calculate_complex_6_coef(handles.R,handles.Ftau,handles.t,str2double(get(handles.A_edit,'String')),str2double(get(handles.a1_edit,'String')),str2double(get(handles.b1_edit,'String')),str2double(get(handles.a2_edit,'String')),str2double(get(handles.b2_edit,'String')),str2double(get(handles.a3_edit,'String')),str2double(get(handles.b3_edit,'String')),str2double(get(handles.a4_edit,'String')),str2double(get(handles.b4_edit,'String')),str2double(get(handles.a5_edit,'String')),str2double(get(handles.b5_edit,'String')),str2double(get(handles.a6_edit,'String')),str2double(get(handles.b6_edit,'String')));
            end

            axes(handles.axes1)
            pcolor(abs(handles.SMC)),shading interp
            set(handles.axes1,'XMinorTick','on')

            % ------------------------------------------------- %
            % --- Selection:                               ---- %
            % --- Monocomponent CTD4                       ---- %
            % ------------------------------------------------- %
        elseif get(handles.radiobutton_Lctd4,'Value')
            handles.ctd4_L=str2double(get(handles.edit_Lform,'String'));
              
            if get(handles.radiobutton1,'Value')
                [handles.LCTD4,handles.CTD4]=calculate_LCTD4(handles.R,handles.Ftau,handles.ctd4_L,handles.t,handles.signal_val)
            elseif get(handles.radiobutton2,'Value')
                [handles.LCTD4,handles.CTD4]=calculate_LCTD4_coef(handles.R,handles.Ftau,handles.ctd4_L,handles.t,str2double(get(handles.A_edit,'String')),str2double(get(handles.a1_edit,'String')),str2double(get(handles.b1_edit,'String')),str2double(get(handles.a2_edit,'String')),str2double(get(handles.b2_edit,'String')),str2double(get(handles.a3_edit,'String')),str2double(get(handles.b3_edit,'String')),str2double(get(handles.a4_edit,'String')),str2double(get(handles.b4_edit,'String')),str2double(get(handles.a5_edit,'String')),str2double(get(handles.b5_edit,'String')),str2double(get(handles.a6_edit,'String')),str2double(get(handles.b6_edit,'String')));
            end
            
            if (handles.ctd4_L==1)
                axes(handles.axes1)
                pcolor(abs(handles.CTD4)),shading interp
                set(handles.axes1,'XMinorTick','on')

            else
                axes(handles.axes1)
                pcolor(abs(handles.LCTD4)),shading interp
                set(handles.axes1,'XMinorTick','on')

            end
            % ------------------------------------------------- %
            % --- Selection:                               ---- %
            % --- Monocomponent CTD6                       ---- %
            % ------------------------------------------------- %
        elseif get(handles.radiobutton_Lctd6,'Value')
            handles.ctd6_L=str2double(get(handles.edit_Lform,'String'));
            
            if get(handles.radiobutton1,'Value')
               [handles.LCTD6,handles.CTD6]=calculate_LCTD6(handles.R,handles.Ftau,handles.ctd6_L,handles.t,handles.signal_val)
            elseif get(handles.radiobutton2,'Value')
                [handles.LCTD6,handles.CTD6]=calculate_LCTD6_coef(handles.R,handles.Ftau,handles.ctd6_L,handles.t,str2double(get(handles.A_edit,'String')),str2double(get(handles.a1_edit,'String')),str2double(get(handles.b1_edit,'String')),str2double(get(handles.a2_edit,'String')),str2double(get(handles.b2_edit,'String')),str2double(get(handles.a3_edit,'String')),str2double(get(handles.b3_edit,'String')),str2double(get(handles.a4_edit,'String')),str2double(get(handles.b4_edit,'String')),str2double(get(handles.a5_edit,'String')),str2double(get(handles.b5_edit,'String')),str2double(get(handles.a6_edit,'String')),str2double(get(handles.b6_edit,'String')));
            end
            
            if (handles.ctd6_L==1)
                axes(handles.axes1)
                pcolor(abs(handles.CTD6)),shading interp
                set(handles.axes1,'XMinorTick','on')

            else
                axes(handles.axes1)
                pcolor(abs(handles.LCTD6)),shading interp
                set(handles.axes1,'XMinorTick','on')
            end
        end
    end

    % ------------------------------------------------- %
    % ---Selection: Multicomponent                 ---- %
    % ------------------------------------------------- %
elseif get(handles.check_multi,'Value')
    % ------------------------------------------------- %
    % ---Selection: Make signal                    ---- %
    % ------------------------------------------------- %
    if get(handles.radiobutton29,'Value')

        handles.Mn=str2double(get(handles.edit_multi,'String'));
        handles.signal_width=str2double(get(handles.edit_length_multi,'String'));
        M=handles.Mn;
        T=0.25;
        handles.t=-(handles.signal_width/2)+2/handles.Mn:2/handles.Mn:(handles.signal_width/2);
        handles.L_multi=str2double(get(handles.edit_L,'String'));
        % ------------------------------------------------- %
        % ---Selection: Make signal, Disabled Compare  ---- %
        % ------------------------------------------------- %
        if ~(get(handles.compare_check,'Value'))
            % ------------------------------------------------- %
            % ---Selection: SPEC MULTI                     ---- %
            % ------------------------------------------------- %
            if get(handles.radiobutton_STFT,'Value')
                handles.spec_multi=calculate_spec_multi(handles.t,handles.N,handles.Ftau,handles.popup_multi1_val);
                axes(handles.axes1)
                pcolor(abs(handles.spec_multi)),shading interp
                set(handles.axes1,'XMinorTick','on')
                % ------------------------------------------------- %
                % ---Selection: WIGNER MULTI                   ---- %
                % ------------------------------------------------- %
            elseif   get(handles.radiobutton_wigner,'Value')
                if ~get(handles.check_ambiguity,'Value')
                    handles.WD_multi=calculate_wd_multi(handles.t,handles.N,handles.Ftau,handles.popup_multi1_val);
                    axes(handles.axes1)
                    pcolor(abs(handles.WD_multi)),shading interp
                    set(handles.axes1,'XMinorTick','on')
                    % ------------------------------------------------- %
                    % ---Selection: WIGNER MULTI, AMBIGUITY DOMAIN ---- %
                    % ------------------------------------------------- %
                else
                     
                    handles.sigma=str2double(get(handles.edit_sigma,'String'));
                    switch (handles.kernel_val)
                        case 1
                            handles.kernel=KernelGauss(str2double(get(handles.edit_multi,'String')),handles.sigma,handles.const1,handles.const2);
                        case 2
                            handles.kernel=KernelChoiW(str2double(get(handles.edit_multi,'String')),handles.sigma,handles.const1,handles.const2);
                        case 3
                            handles.kernel=KernelRectangle(str2double(get(handles.edit_multi,'String')),handles.sigma,handles.const1,handles.const2);
                        case 4
                            handles.kernel=KernelBJ(str2double(get(handles.edit_multi,'String')),handles.const1,handles.const2);
                    end
                    
                    [handles.ctd4_multi_amb,handles.ctr_amb]=calculate_ctd4_multi_amb(handles.t,handles.Mn,handles.kernel,handles.L_multi,handles.popup_amb_val);
                    axes(handles.axes1)

                    a=fftshift(abs(handles.ctr_amb));
                    size(a)
                    imagesc(fftshift(abs(handles.ctr_amb),1)),shading interp
                    set(handles.axes1,'XMinorTick','on')
                    
                end
                % ------------------------------------------------- %
                % ---Selection: S METHOD MULTI                 ---- %
                % ------------------------------------------------- %
            elseif get(handles.radiobutton_sm,'Value')
                handles.SM_multi=calculate_sm_multi(handles.t,handles.N,handles.Ftau,handles.L_multi,handles.popup_multi1_val);
                axes(handles.axes1)
                pcolor(abs(handles.SM_multi)),shading interp
                set(handles.axes1,'XMinorTick','on')
                % ------------------------------------------------- %
                % ---Selection: CTD 4 MULTI                    ---- %
                % ------------------------------------------------- %
            elseif get(handles.radiobutton_ctd4,'Value')


                if ~get(handles.check_ambiguity,'Value')

                    handles.CTD4_multi=calculate_ctd4_multi(handles.t,handles.Mn,handles.Ftau,handles.L_multi,handles.popup_multi1_val);
                    axes(handles.axes1)
                    pcolor(abs(handles.CTD4_multi)),shading interp
                    set(handles.axes1,'XMinorTick','on')
                    % ------------------------------------------------- %
                    % ---Selection: CTD 4 MULTI, AMBIGUITY DOMAIN  ---- %
                    % ------------------------------------------------- %
                else
                    handles.sigma=str2double(get(handles.edit_sigma,'String'));
                    switch (handles.kernel_val)
                        case 1
                            handles.kernel=KernelGauss(str2double(get(handles.edit_multi,'String')),handles.sigma,handles.const1,handles.const2);
                        case 2
                            handles.kernel=KernelChoiW(str2double(get(handles.edit_multi,'String')),handles.sigma,handles.const1,handles.const2);
                        case 3
                            handles.kernel=KernelRectangle(str2double(get(handles.edit_multi,'String')),handles.sigma,handles.const1,handles.const2);
                        case 4
                            handles.kernel=KernelBJ(str2double(get(handles.edit_multi,'String')),handles.const1,handles.const2);
                    end

                    handles.ctd4_multi_amb=calculate_ctd4_multi_amb(handles.t,handles.Mn,handles.kernel,handles.L_multi,handles.popup_amb_val);
                    axes(handles.axes1)
                    a=fftshift(abs(handles.ctd4_multi_amb));
                    size(a)
                    imagesc(fftshift(abs(handles.ctd4_multi_amb),1)),shading interp
                    set(handles.axes1,'XMinorTick','on')
                    set(handles.edit3,'String',num2str(get(handles.popup_multi1,'Value')));
                end
                % ------------------------------------------------- %
                % ---Selection: CTD 6 MULTI,                   ---- %
                % ------------------------------------------------- %
            elseif get(handles.radiobutton_ctd6,'Value')

                if ~get(handles.check_ambiguity,'Value')

                    handles.SMC_multi=calculate_ctd6_multi(handles.t,handles.Mn,handles.Ftau,handles.L_multi,handles.popup_multi1_val);
                    axes(handles.axes1)
                    pcolor(abs(handles.SMC_multi)),shading interp
                    set(handles.axes1,'XMinorTick','on')
                    % ------------------------------------------------- %
                    % ---Selection: CTD 6 MULTI, AMBIGUITY DOMAIN  ---- %
                    % ------------------------------------------------- %
                else
                    handles.sigma=str2double(get(handles.edit_sigma,'String'));
                    switch (handles.kernel_val)
                        case 1
                            handles.kernel=KernelGauss(str2double(get(handles.edit_multi,'String')),handles.sigma,handles.const1,handles.const2);
                        case 2
                            handles.kernel=KernelChoiW(str2double(get(handles.edit_multi,'String')),handles.sigma,handles.const1,handles.const2);
                        case 3
                            handles.kernel=KernelRectangle(str2double(get(handles.edit_multi,'String')),handles.sigma,handles.const1,handles.const2);
                        case 4
                            handles.kernel=KernelBJ(str2double(get(handles.edit_multi,'String')),handles.const1,handles.const2);
                    end
                    
                    handles.ctd6_multi_amb=calculate_ctd6_multi_amb(handles.t,handles.Mn,handles.kernel,handles.L_multi,handles.popup_amb_val);
                    axes(handles.axes1)
                    imagesc((abs(handles.ctd6_multi_amb))),shading interp
                    set(handles.axes1,'XMinorTick','on')

                end
            end
        else
            % ------------------------------------------------- %
            % --- Selection:                               ---- %
            % --- Multicomponent, Compare Enable           ---- %
            % ------------------------------------------------- %
            if ~get(handles.check_ambiguity,'Value')

                handles.WD_multi=calculate_wd_multi(handles.t,handles.N,handles.Ftau,handles.popup_multi1_val);
                axes(handles.axes4)
                pcolor(abs(handles.WD_multi)),shading interp
                set(handles.axes4,'XMinorTick','on')

                handles.CTD4_multi=calculate_ctd4_multi(handles.t,handles.Mn,handles.Ftau,handles.L_multi,handles.popup_multi1_val);
                axes(handles.axes5)
                pcolor(abs(handles.CTD4_multi)),shading interp
                set(handles.axes5,'XMinorTick','on')

                handles.SMC_multi=calculate_ctd6_multi(handles.t,handles.Mn,handles.Ftau,handles.L_multi,handles.popup_multi1_val);
                axes(handles.axes6)
                pcolor(abs(handles.SMC_multi)),shading interp
                set(handles.axes6,'XMinorTick','on')
            else
                
                switch(handles.popup_amb_val)
                    case 1
                        handles.const1=1;
                        handles.const2=1/2;
                        if handles.kernel_val==2
                        end
                    case 2
                        handles.const1=1.5;
                        handles.const2=1;
                end
                handles.sigma=str2double(get(handles.edit_sigma,'String'));
                handles.kernel=KernelGauss(str2double(get(handles.edit_multi,'String')),handles.sigma,handles.const1,handles.const2);
           
                [handles.ctd4_multi_amb,handles.ctr_amb]=calculate_ctd4_multi_amb(handles.t,handles.Mn,handles.kernel,handles.L_multi,handles.popup_amb_val);
                axes(handles.axes4)
                imagesc(fftshift(abs(handles.ctr_amb),1)),shading interp
                set(handles.axes4,'XMinorTick','on')
                axes(handles.axes5)
                imagesc(fftshift(abs(handles.ctd4_multi_amb),1)),shading interp
                set(handles.axes5,'XMinorTick','on')
                
                switch(handles.popup_amb_val)
                    case 1
                        handles.const1=1;
                        handles.const2=1/2;
                        set(handles.edit_L,'String','8')
                        handles.L_multi=str2num(get(handles.edit_L,'String'));
                    case 2
                        handles.const1=1;
                        handles.const2=1/3;
                        set(handles.edit_L,'String','12')
                        handles.L_multi=str2num(get(handles.edit_L,'String'));
                 end
                handles.kernel=KernelGauss(str2double(get(handles.edit_multi,'String')),2*handles.sigma,handles.const1,handles.const2);
                
                handles.ctd6_multi_amb=calculate_ctd6_multi_amb(handles.t,handles.Mn,handles.kernel,handles.L_multi,handles.popup_amb_val);
                axes(handles.axes6)
                imagesc((abs(handles.ctd6_multi_amb))),shading interp
                set(handles.axes6,'XMinorTick','on')
              
            end

        end
        % ------------------------------------------------- %
        % ---Selection: Upload the signal              ---- %
        % ------------------------------------------------- %
    elseif get(handles.radiobutton30,'Value')==1
        if handles.popupmenu15_val==1
            handles.Mn=str2double(get(handles.edit_multi,'String'));

            % ------------------------------------------------- %
            % ---Selection: Flauta                         ---- %
            % ------------------------------------------------- %
            handles.L1=str2double(get(handles.edit58,'String'));
            handles.L2=str2double(get(handles.edit57,'String'));
            cla(handles.axes4); cla(handles.axes5); cla(handles.axes6);
            [handles.SMflauta,handles.SMCflauta]=calculate_flauta_multi_amb(handles.kernel_val,handles.Mn,handles.L1,handles.L2);
            axes(handles.axes4)
            pcolor(log10(abs(handles.SMflauta))),shading interp
            set(handles.axes4,'XMinorTick','on')
            axes(handles.axes5)
            pcolor(log10(abs(handles.SMCflauta))),shading interp
            set(handles.axes5,'XMinorTick','on')
            axes(handles.axes1)
            pcolor(log10(abs(handles.SMCflauta))),shading interp
            set(handles.axes1,'XMinorTick','on')
        elseif handles.popupmenu15_val==2
            % ------------------------------------------------- %
            % ---Selection: Speech                         ---- %
            % ------------------------------------------------- %
            [handles.SM_speech,handles.specspeech]=calculate_speech(str2double(get(handles.edit58,'String')));
            axes(handles.axes4)
            imagesc(20*log10(abs(handles.specspeech(150:400,300:500))')),shading interp,colormap(jet)
            set(handles.axes4,'XMinorTick','on')
            axes(handles.axes5)
            imagesc(20*log10(abs(handles.SM_speech(150:400,300:500))')),shading interp,colormap(jet)
            set(handles.axes5,'XMinorTick','on')

            axes(handles.axes1)
            imagesc(20*log10(abs(handles.SM_speech(150:400,300:500))')),shading interp,colormap(jet)
            set(handles.axes1,'XMinorTick','on')
        elseif handles.popupmenu15_val==3

            [handles.SPEC_ecg,handles.S_ecg]=calculate_ecg(str2double(get(handles.edit58,'String')));
            axes(handles.axes4)
            imagesc(log10(abs(handles.SPEC_ecg(120:380,:)))),shading interp,colormap(jet)
            set(handles.axes4,'XMinorTick','on')
            axes(handles.axes5)
            imagesc(log10(abs(handles.S_ecg(120:380,:)))),shading interp,colormap(jet)
            set(handles.axes5,'XMinorTick','on')

            axes(handles.axes1)
            imagesc(log10(abs(handles.S_ecg(120:380,:)))),shading interp,colormap(jet)
            set(handles.axes1,'XMinorTick','on')
        end
    end
end
guidata(hObject,handles);
% ------------------------------------------------- %
% ---End of PUSHBUTTON1                        ---- %
% ------------------------------------------------- %

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ------------------------------------------------- %
% --- Pushbutton_SIGNAL1 Callback, Create Fcn   --- %
% --- Monocomponent panel Visible               --- %
% --- Parameters for MonoComp. Signals Enabled  --- %
% ------------------------------------------------- %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function pushbutton_signal1_Callback(hObject, eventdata, handles)
set(handles.compare_check,'Enable','on');
set(handles.compare_check,'Value',0);
set(handles.checkbox_mse,'Enable','on');
set(handles.checkbox_mse,'Value',0);
set(handles.uipanel7,'Visible','on');
set(handles.sig2_prop_group,'Visible','off');
set(handles.check_multi,'Value',0);
set(handles.compare_check,'Value',0);
set(handles.compare_edit,'String','4');
set(handles.compare_edit,'Enable','off');
set(handles.axes7,'Visible','on');
set(handles.popup1,'Visible','on');
set(handles.popup2,'Visible','on');
set(handles.popup3,'Visible','on');
set(handles.popup4,'Visible','on');
set(handles.popup1,'Enable','off');
set(handles.popup2,'Enable','off');
set(handles.popup3,'Enable','off');
set(handles.popup4,'Enable','off');
set(handles.popup1m,'Visible','off');
set(handles.popup2m,'Visible','off');
set(handles.popup3m,'Visible','off');
set(handles.text75,'Visible','off');
set(handles.text76,'Visible','off');
set(handles.text78,'Visible','off');
set(handles.uipanel4,'Visible','on');
set(handles.uipanel_ambiguity,'Visible','off');
if (get(handles.check_multi,'Value')==1)
    set(handles.radiobutton_Lctd4,'Enable','off');
    set(handles.radiobutton_Lctd6,'Enable','off');
else
    set(handles.radiobutton_Lctd4,'Enable','on');
    set(handles.radiobutton_Lctd6,'Enable','on');
end
cla(handles.axes4)
cla(handles.axes5)
cla(handles.axes6)
cla(handles.axes7)
cla(handles.axes1)

set(handles.checkbox_mse,'Enable','on')
set(handles.checkbox_conc,'Enable','on')
set(handles.checkbox_mse,'Value',0)
set(handles.checkbox_conc,'Value',0)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ------------------------------------------------- %
% --- Pushbutton_SIGNAL2 Callback, Create Fcn   --- %
% --- Multicomponent panel Visible              --- %
% --- Parameters for MultiComp. Signals Enabled --- %
% ------------------------------------------------- %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function pushbutton_signal2_Callback(hObject, eventdata, handles)

set(handles.compare_check,'Enable','on');
set(handles.compare_check,'Value',0);
set(handles.radiobutton_STFT,'Enable','on');
set(handles.radiobutton_wigner,'Enable','on');
set(handles.radiobutton_sm,'Enable','on');
set(handles.radiobutton_ctd4,'Enable','on');
set(handles.radiobutton_ctd6,'Enable','on');

set(handles.uipanel4,'Visible','off');
set(handles.uipanel_ambiguity,'Visible','on');

if(get(handles.radiobutton_STFT,'Value')==1|get(handles.radiobutton_sm,'Value')==1)
    set(handles.check_ambiguity,'Visible','on');
    set(handles.check_ambiguity,'Value',0);
    set(handles.check_ambiguity,'Enable','off');
elseif (get(handles.radiobutton_wigner,'Value')==1|get(handles.radiobutton_ctd4,'Value')==1|get(handles.radiobutton_ctd6,'Value')==1)
    set(handles.check_ambiguity,'Visible','on');
    set(handles.check_ambiguity,'Value',0);
    set(handles.check_ambiguity,'Enable','on');
end
set(handles.uipanel7,'Visible','off');
set(handles.sig2_prop_group,'Visible','on');

set(handles.check_multi,'Value',1);
set(handles.edit1,'String',get(handles.edit_multi,'String'));
set(handles.edit1,'Enable','off');
set(handles.popup_multi1,'Visible','on')
set(handles.popup_amb,'Visible','off')
if (get(handles.check_multi,'Value')==1)
    set(handles.radiobutton_Lctd4,'Enable','off');
    set(handles.radiobutton_Lctd6,'Enable','off');
else
    set(handles.radiobutton_Lctd4,'Enable','on');
    set(handles.radiobutton_Lctd6,'Enable','on');
end
[handles.x,handles.diff_x1,handles.diff_x2]=signal_multi(handles.t,handles.popup_multi1_val);
axes(handles.axes2)
plot(handles.t,handles.x);
axes(handles.axes3)
plot(handles.t,handles.diff_x1),shading interp
hold on
plot(handles.t,handles.diff_x2),shading interp
hold off
set(handles.compare_check,'Value',0);
set(handles.compare_edit,'String','3');
set(handles.compare_edit,'Enable','off');
set(handles.popup1m,'Visible','on');
set(handles.popup2m,'Visible','on');
set(handles.popup3m,'Visible','on');
set(handles.popup1,'Visible','off');
set(handles.popup2,'Visible','off');
set(handles.popup3,'Visible','off');
set(handles.popup4,'Visible','off');
set(handles.text75,'Visible','off');
set(handles.text76,'Visible','off');
set(handles.text78,'Visible','off');
set(handles.compare_edit,'Enable','off');
set(handles.popup1m,'Enable','off');
set(handles.popup2m,'Enable','off');
set(handles.popup3m,'Enable','off');
set(handles.axes7,'Visible','off');
cla(handles.axes1)
cla(handles.axes2)
cla(handles.axes3)
cla(handles.axes4)
cla(handles.axes5)
cla(handles.axes6)
cla(handles.axes7)
set(handles.checkbox_mse,'Enable','off')
set(handles.checkbox_conc,'Enable','off')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% ------------------------------------------------- %
% --- Pushbutton_PLOT Callback, Create Fcn      --- %
% --- PLOT OF SIGNALS MADE BY USER              --- %
% ------------------------------------------------- %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function pushbutton_plot_Callback(hObject, eventdata, handles)
if get(handles.radiobutton2,'Value')
    [handles.x,handles.diff_x]=signal(handles.t,str2double(get(handles.A_edit,'String')),str2double(get(handles.a1_edit,'String')),str2double(get(handles.b1_edit,'String')),str2double(get(handles.a2_edit,'String')),str2double(get(handles.b2_edit,'String')),str2double(get(handles.a3_edit,'String')),str2double( get(handles.b3_edit,'String')),str2double(get(handles.a4_edit,'String')),str2double(get(handles.b4_edit,'String')),str2double(get(handles.a5_edit,'String')),str2double( get(handles.b5_edit,'String')),str2double(get(handles.a6_edit,'String')), str2double(get(handles.b6_edit,'String')));
end
axes(handles.axes2)
plot(handles.t,handles.x);
axes(handles.axes3)
plot(handles.t,handles.diff_x);
set(handles.axes3,'XMinorTick','on')

function compare_check_Callback(hObject, eventdata, handles)

set(handles.edit1,'String',get(handles.edit2,'String'));
set(handles.radiobutton_STFT,'Value',1);

if get(handles.compare_check,'Value')
    set(handles.text75,'Visible','off');
    set(handles.radiobutton_STFT,'Enable','off')
    set(handles.radiobutton_wigner,'Enable','off')
    set(handles.radiobutton_sm,'Enable','off')
    set(handles.radiobutton_Lctd4,'Enable','off')
    set(handles.radiobutton_Lctd6,'Enable','off')
    set(handles.radiobutton_ctd6,'Enable','off')
    set(handles.radiobutton_ctd4,'Enable','off')
    
    if ~get(handles.check_multi,'Value')
        set(handles.checkbox_mse,'Enable','off');
        set(handles.checkbox_conc,'Enable','off');
        set(handles.popup1,'Visible','on');
        set(handles.popup2,'Visible','on');
        set(handles.popup3,'Visible','on');
        set(handles.popup4,'Visible','on');

        set(handles.popup1m,'Visible','off');
        set(handles.popup2m,'Visible','off');
        set(handles.popup3m,'Visible','off');

        set(handles.axes1,'Visible','on');
        set(handles.axes4,'Visible','on');
        set(handles.axes5,'Visible','on');
        set(handles.axes6,'Visible','on');
        set(handles.axes7,'Visible','on');

        set(handles.compare_edit,'Enable','on');
        set(handles.popup1,'Enable','on');
        set(handles.popup2,'Enable','on');
        set(handles.popup3,'Enable','on');
        set(handles.popup4,'Enable','on');

        set(handles.uipanel_ambiguity,'Visible','off');
        set(handles.uipanel4,'Visible','on');
        
        set(handles.edit_LL,'Enable','on');
        set(handles.edit_Lform,'Enable','on');
        set(handles.edit_Lform,'String','3')
        set(handles.edit_LL,'String','12');
            
    else
        
        set(handles.popup1,'Visible','off');
        set(handles.popup2,'Visible','off');
        set(handles.popup3,'Visible','off');
        set(handles.popup4,'Visible','off');

        set(handles.popup1m,'Visible','on');
        set(handles.popup2m,'Visible','on');
        set(handles.popup3m,'Visible','on');

        set(handles.axes4,'Visible','on');
        set(handles.axes5,'Visible','on');
        set(handles.axes6,'Visible','on');
        set(handles.axes7,'Visible','off');

        set(handles.compare_edit,'Enable','off');
        set(handles.popup1m,'Enable','on');
        set(handles.popup2m,'Enable','on');
        set(handles.popup3m,'Enable','on');

        set(handles.uipanel_ambiguity,'Visible','on');
        set(handles.uipanel4,'Visible','off');
        set(handles.check_ambiguity,'Enable','on'); 
        handles.kernel_val=1;
        set(handles.popup_kernel,'Enable','off')
    end

else
    
    cla(handles.axes1)
    cla(handles.axes4)
    cla(handles.axes5)
    cla(handles.axes6)
    cla(handles.axes7)

    set(handles.radiobutton_STFT,'Enable','on')
    set(handles.radiobutton_wigner,'Enable','on')
    set(handles.radiobutton_sm,'Enable','on')
    set(handles.radiobutton_ctd6,'Enable','on')
    set(handles.radiobutton_ctd4,'Enable','on')

    if get(handles.check_ambiguity,'Value')
        set(handles.radiobutton_Lctd4,'Enable','off')
        set(handles.radiobutton_Lctd6,'Enable','off')
    else
        set(handles.radiobutton_Lctd4,'Enable','on')
        set(handles.radiobutton_Lctd6,'Enable','on')
    end
    
    if ~get(handles.check_multi,'Value')
        set(handles.checkbox_mse,'Enable','on');
        set(handles.checkbox_conc,'Enable','on');
        set(handles.popup1,'Visible','on');
        set(handles.popup2,'Visible','on');
        set(handles.popup3,'Visible','on');
        set(handles.popup4,'Visible','on');
        set(handles.popup1m,'Visible','off');
        set(handles.popup2m,'Visible','off');
        set(handles.popup3m,'Visible','off');
        set(handles.compare_edit,'Enable','off');
        set(handles.popup1,'Enable','off');
        set(handles.popup2,'Enable','off');
        set(handles.popup3,'Enable','off');
        set(handles.popup4,'Enable','off');

    else
        if handles.popup_amb_val==1
            handles.kernel_val=1;
            set(handles.popup_kernel,'Enable','on')
            handles.const1=1;
            handles.const2=1/2;
            set(handles.edit_sigma,'String','150');
        end
        
        set(handles.axes7,'Visible','off');
        set(handles.popup1,'Visible','off');
        set(handles.popup2,'Visible','off');
        set(handles.popup3,'Visible','off');
        set(handles.popup4,'Visible','off');
        set(handles.popup1m,'Visible','on');
        set(handles.popup2m,'Visible','on');
        set(handles.popup3m,'Visible','on');
        set(handles.compare_edit,'Enable','off');
        set(handles.popup1m,'Enable','off');
        set(handles.popup2m,'Enable','off');
        set(handles.popup3m,'Enable','off');
        
    end
end


function axes2_CreateFcn(hObject, eventdata, handles)
function radiobutton_Lctd6_Callback(hObject, eventdata, handles)
function radiobutton_Lctd4_Callback(hObject, eventdata, handles)
function radiobutton_ctd4_Callback(hObject, eventdata, handles)



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% ------------------------------------------------- %
% ---------------CHECK BOXES----------------------- %
% ------------------------------------------------- %
function check_multi_Callback(hObject, eventdata, handles)
if (get(handles.check_multi,'Value')==1)
    set(handles.radiobutton_ctd4,'Enable','off');
    set(handles.radiobutton_ctd6,'Enable','off');
    set(handles.checkbox_mse,'Enable','off');
    set(handles.checkbox_conc,'Enable','off');
else
    set(handles.radiobutton_ctd4,'Enable','on');
    set(handles.radiobutton_ctd6,'Enable','on');
    set(handles.checkbox_mse,'Enable','on');
    set(handles.checkbox_conc,'Enable','on');
end

function check_ambiguity_Callback(hObject, eventdata, handles)

if get(handles.check_ambiguity,'Value')
    set(handles.uipanel_ambiguity,'Visible','on');
    set(handles.uipanel4,'Visible','off');
    set(handles.popup_multi1,'Visible','off');
    set(handles.popup_amb,'Visible','on');
    set(handles.radiobutton_STFT,'Enable','off');
    set(handles.radiobutton_sm,'Enable','off');
else
    set(handles.uipanel_ambiguity,'Visible','off');
    set(handles.uipanel4,'Visible','on');
    set(handles.popup_multi1,'Visible','on');
    set(handles.popup_amb,'Visible','off');
    set(handles.radiobutton_STFT,'Enable','on');
    set(handles.radiobutton_sm,'Enable','on');
end

function checkbox_mse_Callback(hObject, eventdata, handles)

if get(handles.checkbox_mse,'Value')==1
    set(handles.edit63,'String','0.01');
    set(handles.uipanel34,'Title','Mean Squared Error');
    set(handles.text74,'String','MSE < ');
    set(handles.edit59,'Enable','on');
    set(handles.edit61,'Enable','on');
    set(handles.edit62,'Enable','on');
    set(handles.edit63,'Enable','on');
    set(handles.checkbox_conc,'Enable','off');
    set(handles.compare_check,'Enable','off');
    set(handles.compare_edit,'Enable','off');
    set(handles.radiobutton_STFT,'Enable','off');
    set(handles.radiobutton_wigner,'Enable','off');
    set(handles.radiobutton_sm,'Enable','off');
    set(handles.radiobutton_Lctd4,'Enable','off');
    set(handles.radiobutton_Lctd6,'Enable','off');
    set(handles.radiobutton_ctd4,'Enable','off');
    set(handles.radiobutton_ctd6,'Enable','off');
    set(handles.popup1,'Visible','off');
    set(handles.popup2,'Visible','off');
    set(handles.popup3,'Visible','off');
    set(handles.popup4,'Visible','off');
    set(handles.popup1m,'Visible','off');
    set(handles.popup2m,'Visible','off');
    set(handles.popup3m,'Visible','off');
    set(handles.text75,'String','');
    set(handles.text76,'String','');
    set(handles.text78,'String','');
    set(handles.text75,'Visible','on');
    set(handles.text76,'Visible','on');
    set(handles.text78,'Visible','on');
else
    set(handles.edit63,'String','');
    set(handles.uipanel34,'Title','Mean Squared Error');
    set(handles.text74,'String','MSE < ');
    set(handles.edit59,'Enable','off');
    set(handles.edit61,'Enable','off');
    set(handles.edit62,'Enable','off');
    set(handles.edit63,'Enable','off');
    set(handles.checkbox_conc,'Enable','on');
    set(handles.compare_check,'Enable','on');
    set(handles.compare_edit,'Enable','on');
    set(handles.radiobutton_STFT,'Enable','on');
    set(handles.radiobutton_wigner,'Enable','on');
    set(handles.radiobutton_sm,'Enable','on');
    set(handles.radiobutton_Lctd4,'Enable','on');
    set(handles.radiobutton_Lctd6,'Enable','on');
    set(handles.radiobutton_ctd4,'Enable','on');
    set(handles.radiobutton_ctd6,'Enable','on');
    set(handles.text77,'String','');
    set(handles.popup1,'Visible','on');
    set(handles.popup2,'Visible','on');
    set(handles.popup3,'Visible','on');
    set(handles.popup4,'Visible','on');
    set(handles.edit59,'String','');
    set(handles.edit61,'String','');
    set(handles.edit62,'String','');

    set(handles.text71,'String','');
    set(handles.text72,'String','');
    set(handles.text73,'String','');
    set(handles.text75,'String','');
    set(handles.text76,'String','');
    set(handles.text78,'String','');
    set(handles.text75,'Visible','off');
    set(handles.text76,'Visible','off');
    set(handles.text78,'Visible','off');
    cla(handles.axes1);
    cla(handles.axes4);
    cla(handles.axes5);
    cla(handles.axes6);
end

function wdc_check_Callback(hObject, eventdata, handles)
function checkbox16_Callback(hObject, eventdata, handles)
function checkbox2_Callback(hObject, eventdata, handles)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function checkbox_conc_Callback(hObject, eventdata, handles)
if get(handles.checkbox_conc,'Value')==1
    set(handles.edit63,'String','7');
    set(handles.uipanel34,'Title','Concentration Measure');
    set(handles.text74,'String','M > ');
    set(handles.edit59,'Enable','on');
    set(handles.edit61,'Enable','on');
    set(handles.edit62,'Enable','on');
    set(handles.edit63,'Enable','on');
    
    set(handles.checkbox_mse,'Enable','off');
    set(handles.compare_check,'Enable','off');
    set(handles.compare_edit,'Enable','off');
    set(handles.radiobutton_STFT,'Enable','off');
    set(handles.radiobutton_wigner,'Enable','off');
    set(handles.radiobutton_sm,'Enable','off');
    set(handles.radiobutton_Lctd4,'Enable','off');
    set(handles.radiobutton_Lctd6,'Enable','off');
    set(handles.radiobutton_ctd4,'Enable','off');
    set(handles.radiobutton_ctd6,'Enable','off');
    set(handles.popup1,'Visible','off');
    set(handles.popup2,'Visible','off');
    set(handles.popup3,'Visible','off');
    set(handles.popup4,'Visible','off');
    set(handles.popup1m,'Visible','off');
    set(handles.popup2m,'Visible','off');
    set(handles.popup3m,'Visible','off');
    set(handles.text75,'String','');
    set(handles.text76,'String','');
    set(handles.text78,'String','');
    set(handles.text75,'Visible','on');
    set(handles.text76,'Visible','on');
    set(handles.text78,'Visible','on');
    
else
    set(handles.edit63,'String','');
    set(handles.uipanel34,'Title','Concentration Measure');
    set(handles.text74,'String','M > ');
    set(handles.edit59,'Enable','off');
    set(handles.edit61,'Enable','off');
    set(handles.edit62,'Enable','off');
    set(handles.edit63,'Enable','off');
    
    set(handles.checkbox_mse,'Enable','on');
    set(handles.compare_check,'Enable','on');
    set(handles.compare_edit,'Enable','on');
    set(handles.radiobutton_STFT,'Enable','on');
    set(handles.radiobutton_wigner,'Enable','on');
    set(handles.radiobutton_sm,'Enable','on');
    set(handles.radiobutton_Lctd4,'Enable','on');
    set(handles.radiobutton_Lctd6,'Enable','on');
    set(handles.radiobutton_ctd4,'Enable','on');
    set(handles.radiobutton_ctd6,'Enable','on');
    set(handles.text77,'String','');
    set(handles.popup1,'Visible','on');
    set(handles.popup2,'Visible','on');
    set(handles.popup3,'Visible','on');
    set(handles.popup4,'Visible','on');
    set(handles.edit59,'String','');
    set(handles.edit61,'String','');
    set(handles.edit62,'String','');
    
    set(handles.text71,'String','');
    set(handles.text72,'String','');
    set(handles.text73,'String','');
    set(handles.text75,'Visible','off');
    set(handles.text76,'Visible','off');
    set(handles.text78,'Visible','off');
    cla(handles.axes1);
    cla(handles.axes4);
    cla(handles.axes5);
    cla(handles.axes6);
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function checkbox_conc_CreateFcn(hObject, eventdata, handles)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function clean_axes(varargin)
cla(varargin)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function text76_CreateFcn(hObject, eventdata, handles)

function pushbutton6_Callback(hObject, eventdata, handles)
cla(handles.axes1);
cla(handles.axes4);
cla(handles.axes5);
cla(handles.axes6);
cla(handles.axes7);

function radiobutton30_Callback(hObject, eventdata, handles)

function radiobutton_STFT_Callback(hObject, eventdata, handles)

function popup_amb_Callback(hObject, eventdata, handles)

handles.popup_amb_val = get (hObject,'Value');
list = get(hObject,'String');
handles.popup_amb_name = list{handles.popup_amb_val};

[handles.x,handles.diff_x1,handles.diff_x2]=signal_multi_amb(handles.t,handles.popup_amb_val);
axes(handles.axes2)
plot(handles.t,handles.x);
axes(handles.axes3)
plot(handles.t,handles.diff_x1);
hold on
plot(handles.t,handles.diff_x2);
hold off

switch(handles.popup_amb_val)
    case 1
        if get(handles.compare_check,'Value')
            set(handles.popup_kernel,'Enable','off')
        else
            set(handles.popup_kernel,'Enable','on')
        end
        set(handles.edit_L,'String','8');
        switch (handles.kernel_val)
            case 1 
                handles.const1=1;
                handles.const2=1/2;
                set(handles.edit_sigma,'String','150');
                set(handles.edit_sigma,'Visible','on');
                set(handles.text59,'Visible','on');
            case 2
                handles.const1=2;
                handles.const2=1;
                set(handles.edit_sigma,'String','10');
                set(handles.edit_sigma,'Visible','on');
                set(handles.text59,'Visible','on');
            case 3
                handles.const1=1;
                handles.const2=1;
                set(handles.edit_sigma,'String','120');
                set(handles.edit_sigma,'Visible','on');
                set(handles.text59,'Visible','on');
            case 4
                handles.const1=1;
                handles.const2=10;
                set(handles.edit_sigma,'Visible','off');
                set(handles.text59,'Visible','off');
        end
    case 2
        set(handles.popup_kernel,'Value',1)
        set(handles.popup_kernel,'Enable','off')
        set(handles.edit_sigma,'String','80');
        set(handles.edit_sigma,'Visible','on');
        set(handles.text59,'Visible','on');
        if get(handles.radiobutton_ctd4,'Value')
            handles.const1=1.5;
            handles.const2=1;
            set(handles.edit_sigma,'String','80');
            set(handles.edit_L,'String','8');
        elseif get(handles.radiobutton_ctd6,'Value')
            handles.const1=1;
            handles.const2=1/3;
            set(handles.edit_sigma,'String','150');
            set(handles.edit_L,'String','12');
        end
end

guidata(hObject,handles)
function popup_amb_CreateFcn(hObject, eventdata, handles)

if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

function edit_Lform_Callback(hObject, eventdata, handles)
function edit_Lform_CreateFcn(hObject, eventdata, handles)
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


