function [m,aprox]=mse(matrix_a, diff)
%   MSE  
%   [M,Aprox] = MSE (Matrix_A, Diff)
%   calculates measure of concentration for prosposed distribution
%   Input parameters:  Matrix_A - distribution
%                      Diff - the first derivative
%   Output parameters: M - Mean SQUARED Error
%                      Aprox - Aproximation of the first derivative
%   Paper:"A Virtual Instrument for Time-Frequency Analysis of Signals with
%   Highly Non-Stationary Instantaneous Frequency"
%   Authors: Irena Orovic, Milica Orlandic, Srdjan Stankovic, Zdravko
%   Uskokovic
%   Date: March 2010.
% Copyrigth (c) by authors

D=[];
x=matrix_a;
y=diff;
[M,N]=size(x);
[K,L]=size(y);

for i=1:N
    [c,d]=max(x(:,i));
    D=[D d];
end
aprox=0.8*D-52;
m=mean((aprox-y).^2/128);