function [x,diff_x1,diff_x2]=signal_multi_amb(t,popup_amb_val)
%   SIGNAL_MULTI - MULICOMPONENT TEST SIGNALS FOR AMBIGUITY DOMAIN
%   REALIZATION  
%   [x, diff_x1, diff_x2 ]= SIGNAL_MULTI  (t,varargin)
%
%   Input parameters:  t - time domain
%                      varargin - coefficients of the signal in the case of
%                      creating new signal
%   Output parameters: x -  signal
%                      diff_x1 - the first derivative of the first part of signal x
%                      diff_x2 - the first derivative of the second part of signal x
%   Paper:"A Virtual Instrument for Time-Frequency Analysis of Signals with
%   Highly Non-Stationary Instantaneous Frequency"
%   Authors: Irena Orovic, Milica Orlandic, Srdjan Stankovic, Zdravko
%   Uskokovic
%   Date: March 2010.
% Copyrigth (c) by authors


if (popup_amb_val==1)
    x=1*exp(j*1*(4*cos(pi*t)+2/3*cos(6*pi*t)+1/2*cos(1*pi*t)+7.5*pi*t))+1*exp(j*2*(1*cos(pi*t)+1/2*cos(4*pi*t)+1/4*cos(2*pi*t))-9.5*j*pi*t);
    diff_x1=-4*pi*sin(pi*t)-2/3*6*pi*sin(6*pi*t)-1/2*pi*sin(pi*t)+7.5*pi;
    diff_x2=-2*pi*sin(4*pi*t)-1/2*4*pi*sin(4*pi*t)-1/4*2*pi*sin(2*pi*t)-9.5*pi;
elseif (popup_amb_val==2)
    x=exp(j*1.2*(3*cos(pi*t)+2/3*cos(7*pi*t)+8.5*pi*t))+1*exp(j*2*(1*cos(pi*t)+1/4*cos(2*pi*t)+1/2*cos(6*pi*t)-6.5*pi*t));
    diff_x1=1.2*(-3*pi*sin(pi*t)-2/3*7*pi*sin(7*pi*t)+8.5*pi);
    diff_x2=2*(-pi*sin(pi*t)-1/4*2*sin(2*pi*t)-1/2*6*sin(6*pi*t)-6.5*pi);
end